
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _res=R5
	.DEF _pfat=R6
	.DEF _nbytes=R8

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_font5x7:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x32,0x49,0x79,0x41,0x3E,0x7E,0x11,0x11
	.DB  0x11,0x7E,0x7F,0x49,0x49,0x49,0x36,0x3E
	.DB  0x41,0x41,0x41,0x22,0x7F,0x41,0x41,0x22
	.DB  0x1C,0x7F,0x49,0x49,0x49,0x41,0x7F,0x9
	.DB  0x9,0x9,0x1,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x7F,0x8,0x8,0x8,0x7F,0x0,0x41,0x7F
	.DB  0x41,0x0,0x20,0x40,0x41,0x3F,0x1,0x7F
	.DB  0x8,0x14,0x22,0x41,0x7F,0x40,0x40,0x40
	.DB  0x40,0x7F,0x2,0xC,0x2,0x7F,0x7F,0x4
	.DB  0x8,0x10,0x7F,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x51
	.DB  0x21,0x5E,0x7F,0x9,0x19,0x29,0x46,0x46
	.DB  0x49,0x49,0x49,0x31,0x1,0x1,0x7F,0x1
	.DB  0x1,0x3F,0x40,0x40,0x40,0x3F,0x1F,0x20
	.DB  0x40,0x20,0x1F,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x63,0x14,0x8,0x14,0x63,0x7,0x8,0x70
	.DB  0x8,0x7,0x61,0x51,0x49,0x45,0x43,0x0
	.DB  0x7F,0x41,0x41,0x0,0x2,0x4,0x8,0x10
	.DB  0x20,0x0,0x41,0x41,0x7F,0x0,0x4,0x2
	.DB  0x1,0x2,0x4,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x1,0x2,0x4,0x0,0x20,0x54,0x54
	.DB  0x54,0x78,0x7F,0x48,0x44,0x44,0x38,0x38
	.DB  0x44,0x44,0x44,0x20,0x38,0x44,0x44,0x48
	.DB  0x7F,0x38,0x54,0x54,0x54,0x18,0x8,0x7E
	.DB  0x9,0x1,0x2,0xC,0x52,0x52,0x52,0x3E
	.DB  0x7F,0x8,0x4,0x4,0x78,0x0,0x44,0x7D
	.DB  0x40,0x0,0x20,0x40,0x44,0x3D,0x0,0x7F
	.DB  0x10,0x28,0x44,0x0,0x0,0x41,0x7F,0x40
	.DB  0x0,0x7C,0x4,0x18,0x4,0x78,0x7C,0x8
	.DB  0x4,0x4,0x78,0x38,0x44,0x44,0x44,0x38
	.DB  0x7C,0x14,0x14,0x14,0x8,0x8,0x14,0x14
	.DB  0x18,0x7C,0x7C,0x8,0x4,0x4,0x8,0x48
	.DB  0x54,0x54,0x54,0x20,0x4,0x3F,0x44,0x40
	.DB  0x20,0x3C,0x40,0x40,0x20,0x7C,0x1C,0x20
	.DB  0x40,0x20,0x1C,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x44,0x28,0x10,0x28,0x44,0xC,0x50,0x50
	.DB  0x50,0x3C,0x44,0x64,0x54,0x4C,0x44,0x0
	.DB  0x8,0x36,0x41,0x0,0x0,0x0,0x7F,0x0
	.DB  0x0,0x0,0x41,0x36,0x8,0x0,0x10,0x8
	.DB  0x8,0x10,0x8,0x78,0x46,0x41,0x46,0x78
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x7E,0x11,0x11,0x11,0x7E,0x7F,0x49,0x49
	.DB  0x49,0x31,0x7F,0x49,0x49,0x49,0x36,0x7F
	.DB  0x1,0x1,0x1,0x3,0x70,0x29,0x27,0x21
	.DB  0x7F,0x7F,0x49,0x49,0x49,0x41,0x77,0x8
	.DB  0x7F,0x8,0x77,0x41,0x41,0x41,0x49,0x76
	.DB  0x7F,0x10,0x8,0x4,0x7F,0x7F,0x10,0x9
	.DB  0x4,0x7F,0x7F,0x8,0x14,0x22,0x41,0x20
	.DB  0x41,0x3F,0x1,0x7F,0x7F,0x2,0xC,0x2
	.DB  0x7F,0x7F,0x8,0x8,0x8,0x7F,0x3E,0x41
	.DB  0x41,0x41,0x3E,0x7F,0x1,0x1,0x1,0x7F
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x41
	.DB  0x41,0x22,0x1,0x1,0x7F,0x1,0x1,0x47
	.DB  0x28,0x10,0x8,0x7,0x1E,0x21,0x7F,0x21
	.DB  0x1E,0x63,0x14,0x8,0x14,0x63,0x3F,0x20
	.DB  0x20,0x20,0x5F,0x7,0x8,0x8,0x8,0x7F
	.DB  0x7F,0x40,0x7F,0x40,0x7F,0x3F,0x20,0x3F
	.DB  0x20,0x5F,0x1,0x7F,0x48,0x48,0x30,0x7F
	.DB  0x48,0x30,0x0,0x7F,0x0,0x7F,0x48,0x48
	.DB  0x30,0x41,0x41,0x41,0x49,0x3E,0x7F,0x8
	.DB  0x3E,0x41,0x3E,0x46,0x29,0x19,0x9,0x7F
	.DB  0x20,0x54,0x54,0x54,0x78,0x3C,0x4A,0x4A
	.DB  0x49,0x31,0x7C,0x54,0x54,0x28,0x0,0x7C
	.DB  0x4,0x4,0x4,0xC,0x72,0x2A,0x26,0x22
	.DB  0x7E,0x38,0x54,0x54,0x54,0x18,0x6C,0x10
	.DB  0x7C,0x10,0x6C,0x44,0x44,0x54,0x54,0x38
	.DB  0x7C,0x20,0x10,0x8,0x7C,0x7C,0x21,0x12
	.DB  0x9,0x7C,0x7C,0x10,0x28,0x44,0x0,0x20
	.DB  0x44,0x3C,0x4,0x7C,0x7C,0x8,0x10,0x8
	.DB  0x7C,0x7C,0x10,0x10,0x10,0x7C,0x38,0x44
	.DB  0x44,0x44,0x38,0x7C,0x4,0x4,0x4,0x7C
	.DB  0x7C,0x14,0x14,0x14,0x8,0x38,0x44,0x44
	.DB  0x44,0x20,0x4,0x4,0x7C,0x4,0x4,0x44
	.DB  0x28,0x10,0x8,0x4,0x8,0x14,0x7E,0x14
	.DB  0x8,0x44,0x28,0x10,0x28,0x44,0x3C,0x40
	.DB  0x40,0x7C,0x40,0xC,0x10,0x10,0x10,0x7C
	.DB  0x7C,0x40,0x7C,0x40,0x7C,0x3C,0x20,0x3C
	.DB  0x20,0x7C,0x4,0x7C,0x50,0x50,0x20,0x7C
	.DB  0x50,0x20,0x0,0x7C,0x0,0x7C,0x50,0x50
	.DB  0x20,0x28,0x44,0x44,0x54,0x38,0x7C,0x10
	.DB  0x38,0x44,0x38,0x48,0x54,0x34,0x14,0x7C
_error_msg:
	.DB  LOW(_0x36),HIGH(_0x36),LOW(_0x36+1),HIGH(_0x36+1),LOW(_0x36+13),HIGH(_0x36+13),LOW(_0x36+24),HIGH(_0x36+24)
	.DB  LOW(_0x36+35),HIGH(_0x36+35),LOW(_0x36+48),HIGH(_0x36+48),LOW(_0x36+59),HIGH(_0x36+59),LOW(_0x36+70),HIGH(_0x36+70)
	.DB  LOW(_0x36+86),HIGH(_0x36+86),LOW(_0x36+96),HIGH(_0x36+96),LOW(_0x36+105),HIGH(_0x36+105),LOW(_0x36+123),HIGH(_0x36+123)
	.DB  LOW(_0x36+142),HIGH(_0x36+142),LOW(_0x36+159),HIGH(_0x36+159),LOW(_0x36+174),HIGH(_0x36+174),LOW(_0x36+191),HIGH(_0x36+191)
	.DB  LOW(_0x36+207),HIGH(_0x36+207)
_k1:
	.DB  0x20,0x22,0x2A,0x2B,0x2C,0x5B,0x3D,0x5D
	.DB  0x7C,0x7F,0x0
_tbl10_G103:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G103:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3A:
	.DB  0x30,0x3A,0x2F,0x31,0x2E,0x74,0x78,0x74
_0x0:
	.DB  0x0,0x46,0x52,0x5F,0x44,0x49,0x53,0x4B
	.DB  0x5F,0x45,0x52,0x52,0x0,0x46,0x52,0x5F
	.DB  0x49,0x4E,0x54,0x5F,0x45,0x52,0x52,0x0
	.DB  0x46,0x52,0x5F,0x4E,0x4F,0x54,0x5F,0x52
	.DB  0x45,0x41,0x44,0x59,0x0,0x46,0x52,0x5F
	.DB  0x4E,0x4F,0x5F,0x46,0x49,0x4C,0x45,0x0
	.DB  0x46,0x52,0x5F,0x4E,0x4F,0x5F,0x50,0x41
	.DB  0x54,0x48,0x0,0x46,0x52,0x5F,0x49,0x4E
	.DB  0x56,0x41,0x4C,0x49,0x44,0x5F,0x4E,0x41
	.DB  0x4D,0x45,0x0,0x46,0x52,0x5F,0x44,0x45
	.DB  0x4E,0x49,0x45,0x44,0x0,0x46,0x52,0x5F
	.DB  0x45,0x58,0x49,0x53,0x54,0x0,0x46,0x52
	.DB  0x5F,0x49,0x4E,0x56,0x41,0x4C,0x49,0x44
	.DB  0x5F,0x4F,0x42,0x4A,0x45,0x43,0x54,0x0
	.DB  0x46,0x52,0x5F,0x57,0x52,0x49,0x54,0x45
	.DB  0x5F,0x50,0x52,0x4F,0x54,0x45,0x43,0x54
	.DB  0x45,0x44,0x0,0x46,0x52,0x5F,0x49,0x4E
	.DB  0x56,0x41,0x4C,0x49,0x44,0x5F,0x44,0x52
	.DB  0x49,0x56,0x45,0x0,0x46,0x52,0x5F,0x4E
	.DB  0x4F,0x54,0x5F,0x45,0x4E,0x41,0x42,0x4C
	.DB  0x45,0x44,0x0,0x46,0x52,0x5F,0x4E,0x4F
	.DB  0x5F,0x46,0x49,0x4C,0x45,0x53,0x59,0x53
	.DB  0x54,0x45,0x4D,0x0,0x46,0x52,0x5F,0x4D
	.DB  0x4B,0x46,0x53,0x5F,0x41,0x42,0x4F,0x52
	.DB  0x54,0x45,0x44,0x0,0x46,0x52,0x5F,0x54
	.DB  0x49,0x4D,0x45,0x4F,0x55,0x54,0x0,0x44
	.DB  0x69,0x73,0x6B,0x20,0x69,0x6E,0x69,0x74
	.DB  0x20,0x66,0x61,0x69,0x6C,0x65,0x64,0x21
	.DB  0x0,0x49,0x6E,0x69,0x74,0x20,0x4F,0x4B
	.DB  0x0,0x43,0x61,0x72,0x74,0x20,0x6E,0x6F
	.DB  0x74,0x20,0x70,0x72,0x65,0x73,0x65,0x6E
	.DB  0x74,0x21,0x0,0x43,0x61,0x72,0x74,0x20
	.DB  0x70,0x65,0x72,0x73,0x65,0x6E,0x74,0x21
	.DB  0x0,0x44,0x69,0x73,0x6B,0x20,0x70,0x72
	.DB  0x6F,0x74,0x65,0x63,0x74,0x65,0x64,0x0
	.DB  0x4E,0x4F,0x54,0x20,0x50,0x52,0x4F,0x54
	.DB  0x52,0x45,0x43,0x54,0x20,0x2E,0x2E,0x2E
	.DB  0x6F,0x6B,0x0,0x44,0x72,0x69,0x76,0x65
	.DB  0x20,0x30,0x3A,0x20,0x6D,0x6F,0x75,0x6E
	.DB  0x74,0x65,0x64,0x0,0x66,0x69,0x6C,0x65
	.DB  0x20,0x72,0x65,0x61,0x64,0x20,0x65,0x72
	.DB  0x72,0x0,0x66,0x69,0x6C,0x65,0x20,0x6F
	.DB  0x70,0x65,0x6E,0x20,0x65,0x72,0x72,0x0
	.DB  0x45,0x72,0x72,0x6F,0x72,0x20,0x6D,0x6F
	.DB  0x75,0x6E,0x74,0x65,0x64,0x0
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x2020003:
	.DB  0x1
_0x2040107:
	.DB  0x46,0x41,0x54

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _0x36
	.DW  _0x0*2

	.DW  0x0C
	.DW  _0x36+1
	.DW  _0x0*2+1

	.DW  0x0B
	.DW  _0x36+13
	.DW  _0x0*2+13

	.DW  0x0B
	.DW  _0x36+24
	.DW  _0x0*2+13

	.DW  0x0D
	.DW  _0x36+35
	.DW  _0x0*2+24

	.DW  0x0B
	.DW  _0x36+48
	.DW  _0x0*2+37

	.DW  0x0B
	.DW  _0x36+59
	.DW  _0x0*2+48

	.DW  0x10
	.DW  _0x36+70
	.DW  _0x0*2+59

	.DW  0x0A
	.DW  _0x36+86
	.DW  _0x0*2+75

	.DW  0x09
	.DW  _0x36+96
	.DW  _0x0*2+85

	.DW  0x12
	.DW  _0x36+105
	.DW  _0x0*2+94

	.DW  0x13
	.DW  _0x36+123
	.DW  _0x0*2+112

	.DW  0x11
	.DW  _0x36+142
	.DW  _0x0*2+131

	.DW  0x0F
	.DW  _0x36+159
	.DW  _0x0*2+148

	.DW  0x11
	.DW  _0x36+174
	.DW  _0x0*2+163

	.DW  0x10
	.DW  _0x36+191
	.DW  _0x0*2+180

	.DW  0x0B
	.DW  _0x36+207
	.DW  _0x0*2+196

	.DW  0x08
	.DW  _path
	.DW  _0x3A*2

	.DW  0x12
	.DW  _0x3C
	.DW  _0x0*2+207

	.DW  0x08
	.DW  _0x3C+18
	.DW  _0x0*2+225

	.DW  0x12
	.DW  _0x3C+26
	.DW  _0x0*2+233

	.DW  0x0E
	.DW  _0x3C+44
	.DW  _0x0*2+251

	.DW  0x0F
	.DW  _0x3C+58
	.DW  _0x0*2+265

	.DW  0x13
	.DW  _0x3C+73
	.DW  _0x0*2+280

	.DW  0x11
	.DW  _0x3C+92
	.DW  _0x0*2+299

	.DW  0x0E
	.DW  _0x3C+109
	.DW  _0x0*2+316

	.DW  0x0E
	.DW  _0x3C+123
	.DW  _0x0*2+330

	.DW  0x0E
	.DW  _0x3C+137
	.DW  _0x0*2+344

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

	.DW  0x01
	.DW  _status_G101
	.DW  _0x2020003*2

	.DW  0x03
	.DW  _fatstr_S1020016000
	.DW  _0x2040107*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 11.04.2011
;Author  : NeVaDa
;Company : home
;Comments:
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <io.h>
;#include <delay.h>
;
;#include <stdlib.h>
;
;#include <stdio.h>
;#include <string.h>
;
;#include "lcd.c"
;// lcd.c
;// LCD 3310 driver
;// Unbuffered version - very small memory footprint
;
;
;#include "lcd.h"
;
;//typedef enum { LCD_CMD  = 0, LCD_DATA = 1 } LcdCmdData;  //       LCD  (  )
;
;#define LCD_CMD  0
;#define LCD_DATA 1
;
;          //  
;//void lcd_send(unsigned char data, LcdCmdData cd);
;void lcd_send(unsigned char data, char cd);
;void lcd_delay(void);                            //  macro function
;
;/*
;const unsigned char font5x7 [][5] = {             // 
;    { 0x00, 0x00, 0x00, 0x00, 0x00 },   // sp
;    { 0x00, 0x00, 0x2f, 0x00, 0x00 },   // !
;    { 0x00, 0x07, 0x00, 0x07, 0x00 },   // "
;    { 0x14, 0x7f, 0x14, 0x7f, 0x14 },   // #
;    { 0x24, 0x2a, 0x7f, 0x2a, 0x12 },   // $
;    { 0x32, 0x34, 0x08, 0x16, 0x26 },   // %
;    { 0x36, 0x49, 0x55, 0x22, 0x50 },   // &
;    { 0x00, 0x05, 0x03, 0x00, 0x00 },   // '
;    { 0x00, 0x1c, 0x22, 0x41, 0x00 },   // (
;    { 0x00, 0x41, 0x22, 0x1c, 0x00 },   // )
;    { 0x14, 0x08, 0x3E, 0x08, 0x14 },   // *
;    { 0x08, 0x08, 0x3E, 0x08, 0x08 },   // +
;    { 0x00, 0x00, 0x50, 0x30, 0x00 },   // ,
;    { 0x10, 0x10, 0x10, 0x10, 0x10 },   // -
;    { 0x00, 0x60, 0x60, 0x00, 0x00 },   // .
;    { 0x20, 0x10, 0x08, 0x04, 0x02 },   // /
;    { 0x3E, 0x51, 0x49, 0x45, 0x3E },   // 0
;    { 0x00, 0x42, 0x7F, 0x40, 0x00 },   // 1
;    { 0x42, 0x61, 0x51, 0x49, 0x46 },   // 2
;    { 0x21, 0x41, 0x45, 0x4B, 0x31 },   // 3
;    { 0x18, 0x14, 0x12, 0x7F, 0x10 },   // 4
;    { 0x27, 0x45, 0x45, 0x45, 0x39 },   // 5
;    { 0x3C, 0x4A, 0x49, 0x49, 0x30 },   // 6
;    { 0x01, 0x71, 0x09, 0x05, 0x03 },   // 7
;    { 0x36, 0x49, 0x49, 0x49, 0x36 },   // 8
;    { 0x06, 0x49, 0x49, 0x29, 0x1E },   // 9
;    { 0x00, 0x36, 0x36, 0x00, 0x00 },   // :
;    { 0x00, 0x56, 0x36, 0x00, 0x00 },   // ;
;    { 0x08, 0x14, 0x22, 0x41, 0x00 },   // <
;    { 0x14, 0x14, 0x14, 0x14, 0x14 },   // =
;    { 0x00, 0x41, 0x22, 0x14, 0x08 },   // >
;    { 0x02, 0x01, 0x51, 0x09, 0x06 },   // ?
;    { 0x32, 0x49, 0x59, 0x51, 0x3E },   // @
;    { 0x7E, 0x11, 0x11, 0x11, 0x7E },   // A
;    { 0x7F, 0x49, 0x49, 0x49, 0x36 },   // B
;    { 0x3E, 0x41, 0x41, 0x41, 0x22 },   // C
;    { 0x7F, 0x41, 0x41, 0x22, 0x1C },   // D
;    { 0x7F, 0x49, 0x49, 0x49, 0x41 },   // E
;    { 0x7F, 0x09, 0x09, 0x09, 0x01 },   // F
;    { 0x3E, 0x41, 0x49, 0x49, 0x7A },   // G
;    { 0x7F, 0x08, 0x08, 0x08, 0x7F },   // H
;    { 0x00, 0x41, 0x7F, 0x41, 0x00 },   // I
;    { 0x20, 0x40, 0x41, 0x3F, 0x01 },   // J
;    { 0x7F, 0x08, 0x14, 0x22, 0x41 },   // K
;    { 0x7F, 0x40, 0x40, 0x40, 0x40 },   // L
;    { 0x7F, 0x02, 0x0C, 0x02, 0x7F },   // M
;    { 0x7F, 0x04, 0x08, 0x10, 0x7F },   // N
;    { 0x3E, 0x41, 0x41, 0x41, 0x3E },   // O
;    { 0x7F, 0x09, 0x09, 0x09, 0x06 },   // P
;    { 0x3E, 0x41, 0x51, 0x21, 0x5E },   // Q
;    { 0x7F, 0x09, 0x19, 0x29, 0x46 },   // R
;    { 0x46, 0x49, 0x49, 0x49, 0x31 },   // S
;    { 0x01, 0x01, 0x7F, 0x01, 0x01 },   // T
;    { 0x3F, 0x40, 0x40, 0x40, 0x3F },   // U
;    { 0x1F, 0x20, 0x40, 0x20, 0x1F },   // V
;    { 0x3F, 0x40, 0x38, 0x40, 0x3F },   // W
;    { 0x63, 0x14, 0x08, 0x14, 0x63 },   // X
;    { 0x07, 0x08, 0x70, 0x08, 0x07 },   // Y
;    { 0x61, 0x51, 0x49, 0x45, 0x43 },   // Z
;    { 0x00, 0x7F, 0x41, 0x41, 0x00 },   // [
;    { 0x55, 0x2A, 0x55, 0x2A, 0x55 },   // 55
;    { 0x00, 0x41, 0x41, 0x7F, 0x00 },   // ]
;    { 0x04, 0x02, 0x01, 0x02, 0x04 },   // ^
;    { 0x40, 0x40, 0x40, 0x40, 0x40 },   // _
;    { 0x00, 0x01, 0x02, 0x04, 0x00 },   // '
;    { 0x20, 0x54, 0x54, 0x54, 0x78 },   // a
;    { 0x7F, 0x48, 0x44, 0x44, 0x38 },   // b
;    { 0x38, 0x44, 0x44, 0x44, 0x20 },   // c
;    { 0x38, 0x44, 0x44, 0x48, 0x7F },   // d
;    { 0x38, 0x54, 0x54, 0x54, 0x18 },   // e
;    { 0x08, 0x7E, 0x09, 0x01, 0x02 },   // f
;    { 0x0C, 0x52, 0x52, 0x52, 0x3E },   // g
;    { 0x7F, 0x08, 0x04, 0x04, 0x78 },   // h
;    { 0x00, 0x44, 0x7D, 0x40, 0x00 },   // i
;    { 0x20, 0x40, 0x44, 0x3D, 0x00 },   // j
;    { 0x7F, 0x10, 0x28, 0x44, 0x00 },   // k
;    { 0x00, 0x41, 0x7F, 0x40, 0x00 },   // l
;    { 0x7C, 0x04, 0x18, 0x04, 0x78 },   // m
;    { 0x7C, 0x08, 0x04, 0x04, 0x78 },   // n
;    { 0x38, 0x44, 0x44, 0x44, 0x38 },   // o
;    { 0x7C, 0x14, 0x14, 0x14, 0x08 },   // p
;    { 0x08, 0x14, 0x14, 0x18, 0x7C },   // q
;    { 0x7C, 0x08, 0x04, 0x04, 0x08 },   // r
;    { 0x48, 0x54, 0x54, 0x54, 0x20 },   // s
;    { 0x04, 0x3F, 0x44, 0x40, 0x20 },   // t
;    { 0x3C, 0x40, 0x40, 0x20, 0x7C },   // u
;    { 0x1C, 0x20, 0x40, 0x20, 0x1C },   // v
;    { 0x3C, 0x40, 0x30, 0x40, 0x3C },   // w
;    { 0x44, 0x28, 0x10, 0x28, 0x44 },   // x
;    { 0x0C, 0x50, 0x50, 0x50, 0x3C },   // y
;    { 0x44, 0x64, 0x54, 0x4C, 0x44 },   // z
; {0x3C,0x0A,0x05,0x0A,0x3C}
;                     //
;
;*/
;const char font5x7[256][5] = {
;  {0x00, 0x00, 0x00, 0x00, 0x00},// 00
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// 01
;  {0x00, 0x07, 0x00, 0x07, 0x00},// 02
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// 03
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// 04
;  {0x23, 0x13, 0x08, 0x64, 0x62},// 05
;  {0x36, 0x49, 0x55, 0x22, 0x50},// 06
;  {0x00, 0x05, 0x03, 0x00, 0x00},// 07
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// 08
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// 09
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// 0A
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// 0B
;  {0x00, 0x50, 0x30, 0x00, 0x00},// 0C
;  {0x08, 0x08, 0x08, 0x08, 0x08},// 0D
;  {0x00, 0x60, 0x60, 0x00, 0x00},// 0E
;  {0x20, 0x10, 0x08, 0x04, 0x02},// 0F
;  {0x00, 0x00, 0x00, 0x00, 0x00},// 10
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// 11
;  {0x00, 0x07, 0x00, 0x07, 0x00},// 12
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// 13
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// 14
;  {0x23, 0x13, 0x08, 0x64, 0x62},// 15
;  {0x36, 0x49, 0x55, 0x22, 0x50},// 16
;  {0x00, 0x05, 0x03, 0x00, 0x00},// 17
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// 18
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// 19
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// 1A
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// 1B
;  {0x00, 0x50, 0x30, 0x00, 0x00},// 1C
;  {0x08, 0x08, 0x08, 0x08, 0x08},// 1D
;  {0x00, 0x60, 0x60, 0x00, 0x00},// 1E
;  {0x20, 0x10, 0x08, 0x04, 0x02},// 1F
;  {0x00, 0x00, 0x00, 0x00, 0x00},// 20 space
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// 21 !
;  {0x00, 0x07, 0x00, 0x07, 0x00},// 22 "
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// 23 #
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// 24 $
;  {0x23, 0x13, 0x08, 0x64, 0x62},// 25 %
;  {0x36, 0x49, 0x55, 0x22, 0x50},// 26 &
;  {0x00, 0x05, 0x03, 0x00, 0x00},// 27 '
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// 28 (
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// 29 )
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// 2a *
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// 2b +
;  {0x00, 0x50, 0x30, 0x00, 0x00},// 2c ,
;  {0x08, 0x08, 0x08, 0x08, 0x08},// 2d -
;  {0x00, 0x60, 0x60, 0x00, 0x00},// 2e .
;  {0x20, 0x10, 0x08, 0x04, 0x02},// 2f /
;  {0x3E, 0x51, 0x49, 0x45, 0x3E},// 30 0
;  {0x00, 0x42, 0x7F, 0x40, 0x00},// 31 1
;  {0x42, 0x61, 0x51, 0x49, 0x46},// 32 2
;  {0x21, 0x41, 0x45, 0x4B, 0x31},// 33 3
;  {0x18, 0x14, 0x12, 0x7F, 0x10},// 34 4
;  {0x27, 0x45, 0x45, 0x45, 0x39},// 35 5
;  {0x3C, 0x4A, 0x49, 0x49, 0x30},// 36 6
;  {0x01, 0x71, 0x09, 0x05, 0x03},// 37 7
;  {0x36, 0x49, 0x49, 0x49, 0x36},// 38 8
;  {0x06, 0x49, 0x49, 0x29, 0x1E},// 39 9
;  {0x00, 0x36, 0x36, 0x00, 0x00},// 3a :
;  {0x00, 0x56, 0x36, 0x00, 0x00},// 3b ;
;  {0x08, 0x14, 0x22, 0x41, 0x00},// 3c <
;  {0x14, 0x14, 0x14, 0x14, 0x14},// 3d =
;  {0x00, 0x41, 0x22, 0x14, 0x08},// 3e >
;  {0x02, 0x01, 0x51, 0x09, 0x06},// 3f ?
;  {0x32, 0x49, 0x79, 0x41, 0x3E},// 40 @
;  {0x7E, 0x11, 0x11, 0x11, 0x7E},// 41 A
;  {0x7F, 0x49, 0x49, 0x49, 0x36},// 42 B
;  {0x3E, 0x41, 0x41, 0x41, 0x22},// 43 C
;  {0x7F, 0x41, 0x41, 0x22, 0x1C},// 44 D
;  {0x7F, 0x49, 0x49, 0x49, 0x41},// 45 E
;  {0x7F, 0x09, 0x09, 0x09, 0x01},// 46 F
;  {0x3E, 0x41, 0x49, 0x49, 0x7A},// 47 G
;  {0x7F, 0x08, 0x08, 0x08, 0x7F},// 48 H
;  {0x00, 0x41, 0x7F, 0x41, 0x00},// 49 I
;  {0x20, 0x40, 0x41, 0x3F, 0x01},// 4a J
;  {0x7F, 0x08, 0x14, 0x22, 0x41},// 4b K
;  {0x7F, 0x40, 0x40, 0x40, 0x40},// 4c L
;  {0x7F, 0x02, 0x0C, 0x02, 0x7F},// 4d M
;  {0x7F, 0x04, 0x08, 0x10, 0x7F},// 4e N
;  {0x3E, 0x41, 0x41, 0x41, 0x3E},// 4f O
;  {0x7F, 0x09, 0x09, 0x09, 0x06},// 50 P
;  {0x3E, 0x41, 0x51, 0x21, 0x5E},// 51 Q
;  {0x7F, 0x09, 0x19, 0x29, 0x46},// 52 R
;  {0x46, 0x49, 0x49, 0x49, 0x31},// 53 S
;  {0x01, 0x01, 0x7F, 0x01, 0x01},// 54 T
;  {0x3F, 0x40, 0x40, 0x40, 0x3F},// 55 U
;  {0x1F, 0x20, 0x40, 0x20, 0x1F},// 56 V
;  {0x3F, 0x40, 0x38, 0x40, 0x3F},// 57 W
;  {0x63, 0x14, 0x08, 0x14, 0x63},// 58 X
;  {0x07, 0x08, 0x70, 0x08, 0x07},// 59 Y
;  {0x61, 0x51, 0x49, 0x45, 0x43},// 5a Z
;  {0x00, 0x7F, 0x41, 0x41, 0x00},// 5b [
;  {0x02, 0x04, 0x08, 0x10, 0x20},// 5c Yen Currency Sign
;  {0x00, 0x41, 0x41, 0x7F, 0x00},// 5d ]
;  {0x04, 0x02, 0x01, 0x02, 0x04},// 5e ^
;  {0x40, 0x40, 0x40, 0x40, 0x40},// 5f _
;  {0x00, 0x01, 0x02, 0x04, 0x00},// 60 `
;  {0x20, 0x54, 0x54, 0x54, 0x78},// 61 a
;  {0x7F, 0x48, 0x44, 0x44, 0x38},// 62 b
;  {0x38, 0x44, 0x44, 0x44, 0x20},// 63 c
;  {0x38, 0x44, 0x44, 0x48, 0x7F},// 64 d
;  {0x38, 0x54, 0x54, 0x54, 0x18},// 65 e
;  {0x08, 0x7E, 0x09, 0x01, 0x02},// 66 f
;  {0x0C, 0x52, 0x52, 0x52, 0x3E},// 67 g
;  {0x7F, 0x08, 0x04, 0x04, 0x78},// 68 h
;  {0x00, 0x44, 0x7D, 0x40, 0x00},// 69 i
;  {0x20, 0x40, 0x44, 0x3D, 0x00},// 6a j
;  {0x7F, 0x10, 0x28, 0x44, 0x00},// 6b k
;  {0x00, 0x41, 0x7F, 0x40, 0x00},// 6c l
;  {0x7C, 0x04, 0x18, 0x04, 0x78},// 6d m
;  {0x7C, 0x08, 0x04, 0x04, 0x78},// 6e n
;  {0x38, 0x44, 0x44, 0x44, 0x38},// 6f o
;  {0x7C, 0x14, 0x14, 0x14, 0x08},// 70 p
;  {0x08, 0x14, 0x14, 0x18, 0x7C},// 71 q
;  {0x7C, 0x08, 0x04, 0x04, 0x08},// 72 r
;  {0x48, 0x54, 0x54, 0x54, 0x20},// 73 s
;  {0x04, 0x3F, 0x44, 0x40, 0x20},// 74 t
;  {0x3C, 0x40, 0x40, 0x20, 0x7C},// 75 u
;  {0x1C, 0x20, 0x40, 0x20, 0x1C},// 76 v
;  {0x3C, 0x40, 0x30, 0x40, 0x3C},// 77 w
;  {0x44, 0x28, 0x10, 0x28, 0x44},// 78 x
;  {0x0C, 0x50, 0x50, 0x50, 0x3C},// 79 y
;  {0x44, 0x64, 0x54, 0x4C, 0x44},// 7a z
;  {0x00, 0x08, 0x36, 0x41, 0x00},// 7b <
;  {0x00, 0x00, 0x7F, 0x00, 0x00},// 7c |
;  {0x00, 0x41, 0x36, 0x08, 0x00},// 7d >
;  {0x10, 0x08, 0x08, 0x10, 0x08},// 7e Right Arrow         ->
;  {0x78, 0x46, 0x41, 0x46, 0x78},// 7f Left Arrow        <-
;  {0x00, 0x00, 0x00, 0x00, 0x00},// 80
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// 81
;  {0x00, 0x07, 0x00, 0x07, 0x00},// 82
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// 83
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// 84
;  {0x23, 0x13, 0x08, 0x64, 0x62},// 85
;  {0x36, 0x49, 0x55, 0x22, 0x50},// 86
;  {0x00, 0x05, 0x03, 0x00, 0x00},// 87
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// 88
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// 89
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// 8A
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// 8B
;  {0x00, 0x50, 0x30, 0x00, 0x00},// 8C
;  {0x08, 0x08, 0x08, 0x08, 0x08},// 8D
;  {0x00, 0x60, 0x60, 0x00, 0x00},// 8E
;  {0x20, 0x10, 0x08, 0x04, 0x02},// 8F
;  {0x00, 0x00, 0x00, 0x00, 0x00},// 90
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// 91
;  {0x00, 0x07, 0x00, 0x07, 0x00},// 92
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// 93
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// 94
;  {0x23, 0x13, 0x08, 0x64, 0x62},// 95
;  {0x36, 0x49, 0x55, 0x22, 0x50},// 96
;  {0x00, 0x05, 0x03, 0x00, 0x00},// 97
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// 98
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// 99
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// 9A
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// 9B
;  {0x00, 0x50, 0x30, 0x00, 0x00},// 9C
;  {0x08, 0x08, 0x08, 0x08, 0x08},// 9D
;  {0x00, 0x60, 0x60, 0x00, 0x00},// 9E
;  {0x20, 0x10, 0x08, 0x04, 0x02},// 9F
;  {0x00, 0x00, 0x00, 0x00, 0x00},// A0
;  {0x00, 0x00, 0x5F, 0x00, 0x00},// A1
;  {0x00, 0x07, 0x00, 0x07, 0x00},// A2
;  {0x14, 0x7F, 0x14, 0x7F, 0x14},// A3
;  {0x24, 0x2A, 0x7F, 0x2A, 0x12},// A4
;  {0x23, 0x13, 0x08, 0x64, 0x62},// A5
;  {0x36, 0x49, 0x55, 0x22, 0x50},// A6
;  {0x00, 0x05, 0x03, 0x00, 0x00},// A7
;  {0x00, 0x1C, 0x22, 0x41, 0x00},// A8
;  {0x00, 0x41, 0x22, 0x1C, 0x00},// A9
;  {0x14, 0x08, 0x3E, 0x08, 0x14},// AA
;  {0x08, 0x08, 0x3E, 0x08, 0x08},// AB
;  {0x00, 0x50, 0x30, 0x00, 0x00},// AC
;  {0x08, 0x08, 0x08, 0x08, 0x08},// AD
;  {0x00, 0x60, 0x60, 0x00, 0x00},// AE
;  {0x20, 0x10, 0x08, 0x04, 0x02},// AF
;  {0x3E, 0x51, 0x49, 0x45, 0x3E},// B0
;  {0x00, 0x42, 0x7F, 0x40, 0x00},// B1
;  {0x42, 0x61, 0x51, 0x49, 0x46},// B2
;  {0x21, 0x41, 0x45, 0x4B, 0x31},// B3
;  {0x18, 0x14, 0x12, 0x7F, 0x10},// B4
;  {0x27, 0x45, 0x45, 0x45, 0x39},// B5
;  {0x3C, 0x4A, 0x49, 0x49, 0x30},// B6
;  {0x01, 0x71, 0x09, 0x05, 0x03},// B7
;  {0x36, 0x49, 0x49, 0x49, 0x36},// B8
;  {0x06, 0x49, 0x49, 0x29, 0x1E},// B9
;  {0x00, 0x36, 0x36, 0x00, 0x00},// BA
;  {0x00, 0x56, 0x36, 0x00, 0x00},// BB
;  {0x08, 0x14, 0x22, 0x41, 0x00},// BC
;  {0x14, 0x14, 0x14, 0x14, 0x14},// BD
;  {0x00, 0x41, 0x22, 0x14, 0x08},// BE
;  {0x02, 0x01, 0x51, 0x09, 0x06},// BF
;  {0x7E, 0x11, 0x11, 0x11, 0x7E},// C0 
;  {0x7F, 0x49, 0x49, 0x49, 0x31},// C1 
;  {0x7F, 0x49, 0x49, 0x49, 0x36},// C2 
;  {0x7F, 0x01, 0x01, 0x01, 0x03},// C3 
;  {0x70, 0x29, 0x27, 0x21, 0x7F},// C4 
;  {0x7F, 0x49, 0x49, 0x49, 0x41},// C5 
;  {0x77, 0x08, 0x7F, 0x08, 0x77},// C6 
;  {0x41, 0x41, 0x41, 0x49, 0x76},// C7 
;  {0x7F, 0x10, 0x08, 0x04, 0x7F},// C8 
;  {0x7F, 0x10, 0x09, 0x04, 0x7F},// C9 
;  {0x7F, 0x08, 0x14, 0x22, 0x41},// CA 
;  {0x20, 0x41, 0x3F, 0x01, 0x7F},// CB 
;  {0x7F, 0x02, 0x0C, 0x02, 0x7F},// CC 
;  {0x7F, 0x08, 0x08, 0x08, 0x7F},// CD 
;  {0x3E, 0x41, 0x41, 0x41, 0x3E},// CE 
;  {0x7F, 0x01, 0x01, 0x01, 0x7F},// CF 
;  {0x7F, 0x09, 0x09, 0x09, 0x06},// D0 
;  {0x3E, 0x41, 0x41, 0x41, 0x22},// D1 
;  {0x01, 0x01, 0x7F, 0x01, 0x01},// D2 
;  {0x47, 0x28, 0x10, 0x08, 0x07},// D3 
;  {0x1E, 0x21, 0x7F, 0x21, 0x1E},// D4 
;  {0x63, 0x14, 0x08, 0x14, 0x63},// D5 
;  {0x3F, 0x20, 0x20, 0x20, 0x5F},// D6 
;  {0x07, 0x08, 0x08, 0x08, 0x7F},// D7 
;  {0x7F, 0x40, 0x7F, 0x40, 0x7F},// D8 
;  {0x3F, 0x20, 0x3F, 0x20, 0x5F},// D9 
;  {0x01, 0x7F, 0x48, 0x48, 0x30},// DA 
;  {0x7F, 0x48, 0x30, 0x00, 0x7F},// DB 
;  {0x00, 0x7F, 0x48, 0x48, 0x30},// DC 
;  {0x41, 0x41, 0x41, 0x49, 0x3E},// DD 
;  {0x7F, 0x08, 0x3E, 0x41, 0x3E},// DE 
;  {0x46, 0x29, 0x19, 0x09, 0x7F},// DF 
;  {0x20, 0x54, 0x54, 0x54, 0x78},// E0 
;  {0x3C, 0x4A, 0x4A, 0x49, 0x31},// E1 
;  {0x7C, 0x54, 0x54, 0x28, 0x00},// E2 
;  {0x7C, 0x04, 0x04, 0x04, 0x0C},// E3 
;  {0x72, 0x2A, 0x26, 0x22, 0x7E},// E4 
;  {0x38, 0x54, 0x54, 0x54, 0x18},// E5 
;  {0x6C, 0x10, 0x7C, 0x10, 0x6C},// E6 
;  {0x44, 0x44, 0x54, 0x54, 0x38},// E7 
;  {0x7C, 0x20, 0x10, 0x08, 0x7C},// E8 
;  {0x7C, 0x21, 0x12, 0x09, 0x7C},// E9 
;  {0x7C, 0x10, 0x28, 0x44, 0x00},// EA 
;  {0x20, 0x44, 0x3C, 0x04, 0x7C},// EB 
;  {0x7C, 0x08, 0x10, 0x08, 0x7C},// EC 
;  {0x7C, 0x10, 0x10, 0x10, 0x7C},// ED 
;  {0x38, 0x44, 0x44, 0x44, 0x38},// EE 
;  {0x7C, 0x04, 0x04, 0x04, 0x7C},// EF 
;  {0x7C, 0x14, 0x14, 0x14, 0x08},// F0 
;  {0x38, 0x44, 0x44, 0x44, 0x20},// F1 
;  {0x04, 0x04, 0x7C, 0x04, 0x04},// F2 
;  {0x44, 0x28, 0x10, 0x08, 0x04},// F3 
;  {0x08, 0x14, 0x7E, 0x14, 0x08},// F4 
;  {0x44, 0x28, 0x10, 0x28, 0x44},// F5 
;  {0x3C, 0x40, 0x40, 0x7C, 0x40},// F6 
;  {0x0C, 0x10, 0x10, 0x10, 0x7C},// F7 
;  {0x7C, 0x40, 0x7C, 0x40, 0x7C},// F8 
;  {0x3C, 0x20, 0x3C, 0x20, 0x7C},// F9 
;  {0x04, 0x7C, 0x50, 0x50, 0x20},// FA 
;  {0x7C, 0x50, 0x20, 0x00, 0x7C},// FB 
;  {0x00, 0x7C, 0x50, 0x50, 0x20},// FC 
;  {0x28, 0x44, 0x44, 0x54, 0x38},// FD 
;  {0x7C, 0x10, 0x38, 0x44, 0x38},// FE 
;  {0x48, 0x54, 0x34, 0x14, 0x7C} // FF 
;} ;
;
;
;void Lcd_Mode (unsigned char mode) 		// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
; 0000 0022 {

	.CSEG
;    if (mode > 3) return;
;	mode -> Y+0
;    lcd_send( 0b00001000|((mode<<1|mode)&0b00000101), LCD_CMD ); 	//LCD mode
;}
;
;void lcd_delay(void)
;{
_lcd_delay:
;  int i;
;
;     for(i=-32000; i<32000; i++);  //  macro function
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,-32000
_0x5:
	__CPWRN 16,17,32000
	BRGE _0x6
	__ADDWRN 16,17,1
	RJMP _0x5
_0x6:
;}
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;
;void lcd_clear(void) {  //  
_lcd_clear:
;  unsigned int i;
;
;  lcd_goto_xy(0,0);
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CALL SUBOPT_0x0
	CALL SUBOPT_0x0
	RCALL _lcd_goto_xy
;  for (i=0;i<504;++i)
	__GETWRN 16,17,0
_0x8:
	__CPWRN 16,17,504
	BRSH _0x9
;    {
;     lcd_send(0x00, LCD_DATA);
	CALL SUBOPT_0x1
;    }
	__ADDWRN 16,17,1
	RJMP _0x8
_0x9:
;}
	JMP  _0x2100012
;
;
;void lcd_init(void)    //  LCD
;{
_lcd_init:
;    LCD_CE_PIN = 0;                   // Enable display controller (active low)
	CBI  0x15,0
;    LCD_CLK_PIN = 0;
	CBI  0x15,3
;    LCD_RST_PIN = 1;          //  Reset = 1
	SBI  0x15,4
;
;    LCD_Vdd = 1;              //    LCD
	SBI  0x15,5
;//	LCD_DDR |= LCD_RST_PIN | LCD_CE_PIN | LCD_DC_PIN | LCD_DATA_PIN | LCD_CLK_PIN;   // Set output bits on lcd port
;
;    delay_ms(15);             //    VCC LCD (max 30ms)
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL SUBOPT_0x2
;    LCD_RST_PIN = 0;          //  LCD (Reset = 0)
	CBI  0x15,4
;    lcd_delay();
	RCALL _lcd_delay
;    LCD_RST_PIN = 1;          //   (Reset = 1)
	SBI  0x15,4
;
;    lcd_send(0x21, LCD_CMD);  //  LCD    
	CALL SUBOPT_0x3
;    lcd_send(0xC8, LCD_CMD);  // Set LCD Vop(Contrast = 72 = 80h + 48h)
	LDI  R30,LOW(200)
	CALL SUBOPT_0x4
;    lcd_send(0x06, LCD_CMD);  //   
	LDI  R30,LOW(6)
	CALL SUBOPT_0x4
;    lcd_send(0x13, LCD_CMD);  // LCD bias mode 1:48
	LDI  R30,LOW(19)
	CALL SUBOPT_0x4
;    lcd_send(0x20, LCD_CMD);  //  LCD   c ,   ( )
	LDI  R30,LOW(32)
	CALL SUBOPT_0x4
;    lcd_send(0x0C, LCD_CMD);  // LCD     (  )
	LDI  R30,LOW(12)
	CALL SUBOPT_0x4
;
;    lcd_clear();              //  lcd
	RCALL _lcd_clear
;}
	RET
;
;
;void lcd_contrast(unsigned char contrast)  {    //  
_lcd_contrast:
;	lcd_send(0x21, LCD_CMD);			    	//  LCD    
;	contrast -> Y+0
	CALL SUBOPT_0x3
;    lcd_send(0x80 | contrast, LCD_CMD);	    	// Set LCD Vop(Contrast 0-127 {0-7Fh} )
	LD   R30,Y
	ORI  R30,0x80
	CALL SUBOPT_0x4
;    lcd_send(0x20, LCD_CMD);				    //  ,  
	LDI  R30,LOW(32)
	CALL SUBOPT_0x4
;}
	JMP  _0x2100014
;
;
;
;void lcd_clear_area(unsigned int line, unsigned char startX, unsigned char endX)  //    
;{                                                                                 //  
; unsigned int i;                                                                  //  
;
;    int start = ((int)line)*84+((int)startX);  //    
;    int end = ((int)line)*84+((int)endX);      //    
;
;    lcd_goto_xy((start % LCD_X_RES),(start / LCD_X_RES));
;	line -> Y+8
;	startX -> Y+7
;	endX -> Y+6
;	i -> R16,R17
;	start -> R18,R19
;	end -> R20,R21
;
;    for(i=start;i<end;i++) {      //     
;        lcd_send(0, LCD_DATA);
;    }
;}
;
;
;void lcd_clear_line(unsigned int line)  //   (8   )
;{
;   lcd_clear_area(line, 1, LCD_X_RES);
;	line -> Y+0
;}
;
;
;void lcd_goto_xy(unsigned int x, unsigned int y) //    X () Y ()
;{
_lcd_goto_xy:
;    lcd_send (x | 0x80, LCD_CMD);
;	x -> Y+2
;	y -> Y+0
	LDD  R30,Y+2
	ORI  R30,0x80
	CALL SUBOPT_0x4
;    lcd_send ((y-1) | 0x40, LCD_CMD);
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,1
	ORI  R30,0x40
	CALL SUBOPT_0x4
;}
	ADIW R28,4
	RET
;
;
;void lcd_chr(char chr)    //    LCD    
;{
_lcd_chr:
;  unsigned char i;
;
;    for(i=0;i<5;i++)                 //   5 
	ST   -Y,R17
;	chr -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x1A:
	CPI  R17,5
	BRSH _0x1B
;	{
;      lcd_send(font5x7[chr][i], LCD_DATA);
	LDD  R30,Y+1
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_font5x7*2)
	SBCI R31,HIGH(-_font5x7*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_send
;    }
	SUBI R17,-1
	RJMP _0x1A
_0x1B:
;	lcd_send(0, LCD_DATA);           //    
	CALL SUBOPT_0x1
;}
	LDD  R17,Y+0
	RJMP _0x2100017
;
;
;void lcd_str(char *str)   //    LCD    
;{
_lcd_str:
;   while(*str)
;	*str -> Y+0
_0x1C:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x1E
;       lcd_chr(*str++);
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	ST   -Y,R30
	RCALL _lcd_chr
	RJMP _0x1C
_0x1E:
_0x2100017:
	ADIW R28,2
	RET
;
;
;void lcd_send(unsigned char data, char cd)   // Sends data to display controller
;{ unsigned char i;
_lcd_send:
;
;    if(cd == LCD_DATA)                //   
	ST   -Y,R17
;	data -> Y+2
;	cd -> Y+1
;	i -> R17
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRNE _0x1F
;       LCD_DC_PIN = 1;                // 
	SBI  0x15,1
;    else
	RJMP _0x22
_0x1F:
;       LCD_DC_PIN = 0;                // 
	CBI  0x15,1
;
;	for(i=0;i<8;i++)
_0x22:
	LDI  R17,LOW(0)
_0x26:
	CPI  R17,8
	BRSH _0x27
;    {
;		if((data>>(7-i)) & 0x01)      //    DATA
	LDD  R22,Y+2
	CLR  R23
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	CALL __ASRW12
	ANDI R30,LOW(0x1)
	BREQ _0x28
;   		    LCD_DATA_PIN = 1;
	SBI  0x15,2
;	    else
	RJMP _0x2B
_0x28:
;	   	    LCD_DATA_PIN = 0;
	CBI  0x15,2
;
;   		LCD_CLK_PIN = 1;              //  CLK
_0x2B:
	SBI  0x15,3
;        LCD_CLK_PIN = 0;
	CBI  0x15,3
;	}
	SUBI R17,-1
	RJMP _0x26
_0x27:
;
;	// Data/DC can be used as button inputs when not sending to LCD (/w pullups)
;	// LCD_DDR &= ~(LCD_DATA_PIN | LCD_DC_PIN);
;	LCD_DATA_PIN = 1;
	SBI  0x15,2
;    LCD_DC_PIN   = 1;
	SBI  0x15,1
;}
	LDD  R17,Y+0
	ADIW R28,3
	RET
;
;
;
;// SPI functions
;#include <spi.h>
;
;#include <sdcard.h>
;#include <ff.h>
;
;
;unsigned char Buffer[256];
;
;FRESULT res;
;FATFS fat;
;FIL file_1;
;
;FATFS *pfat;
;
;char *flash error_msg[] =
;{
;"",
;"FR_DISK_ERR",
;"FR_INT_ERR",
;"FR_INT_ERR",
;"FR_NOT_READY",
;"FR_NO_FILE",
;"FR_NO_PATH",
;"FR_INVALID_NAME",
;"FR_DENIED",
;"FR_EXIST",
;"FR_INVALID_OBJECT",
;"FR_WRITE_PROTECTED",
;"FR_INVALID_DRIVE",
;"FR_NOT_ENABLED",
;"FR_NO_FILESYSTEM",
;"FR_MKFS_ABORTED",
;"FR_TIMEOUT"
;};

	.DSEG
_0x36:
	.BYTE 0xDA
;
;
;void error(FRESULT res)
; 0000 004B {

	.CSEG
_error:
; 0000 004C         if ((res>=FR_DISK_ERR)&&(res<=FR_TIMEOUT))
;	res -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRLO _0x38
	CPI  R26,LOW(0x10)
	BRLO _0x39
_0x38:
	RJMP _0x37
_0x39:
; 0000 004D         {
; 0000 004E                 lcd_str(error_msg[res]);
	LD   R30,Y
	LDI  R26,LOW(_error_msg*2)
	LDI  R27,HIGH(_error_msg*2)
	CALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	CALL SUBOPT_0x6
; 0000 004F         }
; 0000 0050 }
_0x37:
	JMP  _0x2100014
;
;
;
;//DIR directory;
;unsigned int nbytes;
;
;
;
;unsigned char path[10] = {"0:/1.txt"};

	.DSEG
;
;
;
;
;
;
;
;
;
;
;
;/*
;==============================================================================================
;           Timer 0
;==============================================================================================
;*/
;
;interrupt [TIM0_OVF] void timer0_ovf_isr (void)
; 0000 006C {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006D 
; 0000 006E TCNT0 = 0x06;
	LDI  R30,LOW(6)
	OUT  0x32,R30
; 0000 006F 
; 0000 0070 disk_timerproc();
	CALL _disk_timerproc
; 0000 0071 
; 0000 0072 
; 0000 0073 
; 0000 0074 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;interrupt [TIM1_OVF] void timer1_ovf_isr (void)
; 0000 0077 {
_timer1_ovf_isr:
	ST   -Y,R30
; 0000 0078 
; 0000 0079 TCNT1H=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2D,R30
; 0000 007A TCNT1L=0x06;
	LDI  R30,LOW(6)
	OUT  0x2C,R30
; 0000 007B 
; 0000 007C 
; 0000 007D 
; 0000 007E 
; 0000 007F }
	LD   R30,Y+
	RETI
;
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 0086 {
_main:
; 0000 0087 // Declare your local variables here
; 0000 0088 
; 0000 0089 unsigned char disk_status;
; 0000 008A 
; 0000 008B char index;
; 0000 008C char chr;
; 0000 008D char stroka;
; 0000 008E 
; 0000 008F // Input/Output Ports initialization
; 0000 0090 // Port A initialization
; 0000 0091 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0092 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0093 PORTA=0x00;
;	disk_status -> R17
;	index -> R16
;	chr -> R19
;	stroka -> R18
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0094 DDRA=0x00;
	OUT  0x1A,R30
; 0000 0095 
; 0000 0096 // Port B initialization
; 0000 0097 // Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0098 // State7=T State6=0 State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0099 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 009A DDRB=0b11111100;
	LDI  R30,LOW(252)
	OUT  0x17,R30
; 0000 009B 
; 0000 009C // Port C initialization
; 0000 009D // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 009E // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 009F PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
; 0000 00A0 DDRC=0xFF;
	OUT  0x14,R30
; 0000 00A1 
; 0000 00A2 // Port D initialization
; 0000 00A3 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00A4 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00A5 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 00A6 DDRD=0x00;
	OUT  0x11,R30
; 0000 00A7 
; 0000 00A8 //  Timer 0
; 0000 00A9 //TCCR0=0x00;
; 0000 00AA TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 00AB TCNT0=0x06;
	LDI  R30,LOW(6)
	OUT  0x32,R30
; 0000 00AC 
; 0000 00AD //  Timer 1
; 0000 00AE TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 00AF TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00B0 TCNT1H=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2D,R30
; 0000 00B1 TCNT1L=0x06;
	LDI  R30,LOW(6)
	OUT  0x2C,R30
; 0000 00B2 OCR1BL=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
; 0000 00B3 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00B4 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00B5 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00B6 
; 0000 00B7 // Timer/Counter 2 initialization
; 0000 00B8 // Clock source: System Clock
; 0000 00B9 // Clock value: Timer2 Stopped
; 0000 00BA // Mode: Normal top=FFh
; 0000 00BB // OC2 output: Disconnected
; 0000 00BC ASSR=0x00;
	OUT  0x22,R30
; 0000 00BD TCCR2=0x00;
	OUT  0x25,R30
; 0000 00BE TCNT2=0x00;
	OUT  0x24,R30
; 0000 00BF OCR2=0x00;
	OUT  0x23,R30
; 0000 00C0 
; 0000 00C1 // External Interrupt(s) initialization
; 0000 00C2 // INT0: Off
; 0000 00C3 // INT1: Off
; 0000 00C4 // INT2: Off
; 0000 00C5 MCUCR=0x00;
	OUT  0x35,R30
; 0000 00C6 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 00C7 
; 0000 00C8 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00C9 TIMSK=0x05;
	LDI  R30,LOW(5)
	OUT  0x39,R30
; 0000 00CA 
; 0000 00CB // Analog Comparator initialization
; 0000 00CC // Analog Comparator: Off
; 0000 00CD // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00CE ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00CF SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00D0 
; 0000 00D1 // spi
; 0000 00D2 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 00D3 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 00D4 
; 0000 00D5 
; 0000 00D6 lcd_init();
	RCALL _lcd_init
; 0000 00D7 lcd_contrast(0x5F);
	LDI  R30,LOW(95)
	ST   -Y,R30
	RCALL _lcd_contrast
; 0000 00D8 
; 0000 00D9 lcd_clear();
	RCALL _lcd_clear
; 0000 00DA 
; 0000 00DB 
; 0000 00DC 
; 0000 00DD 
; 0000 00DE 
; 0000 00DF 
; 0000 00E0 #asm("sei");
	sei
; 0000 00E1 
; 0000 00E2 
; 0000 00E3 
; 0000 00E4 //lcd_str("ok");
; 0000 00E5 
; 0000 00E6 
; 0000 00E7           disk_status = disk_initialize(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _disk_initialize
	MOV  R17,R30
; 0000 00E8 
; 0000 00E9           if (disk_status & STA_NOINIT)
	SBRS R17,0
	RJMP _0x3B
; 0000 00EA           {
; 0000 00EB                 lcd_str("Disk init failed!");
	__POINTW1MN _0x3C,0
	RJMP _0x4C
; 0000 00EC           }
; 0000 00ED           else
_0x3B:
; 0000 00EE           {
; 0000 00EF                 lcd_str("Init OK");
	__POINTW1MN _0x3C,18
_0x4C:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_str
; 0000 00F0           }
; 0000 00F1           if (disk_status & STA_NODISK)
	SBRS R17,1
	RJMP _0x3E
; 0000 00F2           {
; 0000 00F3                  lcd_str("Cart not present!");
	__POINTW1MN _0x3C,26
	RJMP _0x4D
; 0000 00F4           }
; 0000 00F5           else
_0x3E:
; 0000 00F6           {
; 0000 00F7                    lcd_str("Cart persent!");
	__POINTW1MN _0x3C,44
_0x4D:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_str
; 0000 00F8           }
; 0000 00F9 
; 0000 00FA           if (disk_status & STA_PROTECT)
	SBRS R17,2
	RJMP _0x40
; 0000 00FB           {
; 0000 00FC 
; 0000 00FD                 lcd_str("Disk protected");
	__POINTW1MN _0x3C,58
	RJMP _0x4E
; 0000 00FE           }
; 0000 00FF           else
_0x40:
; 0000 0100           {
; 0000 0101                  lcd_str("NOT PROTRECT ...ok");
	__POINTW1MN _0x3C,73
_0x4E:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_str
; 0000 0102           }
; 0000 0103 
; 0000 0104 
; 0000 0105 
; 0000 0106 
; 0000 0107            if ((res = f_mount(0,&fat)) == FR_OK)
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(_fat)
	LDI  R31,HIGH(_fat)
	ST   -Y,R31
	ST   -Y,R30
	CALL _f_mount
	MOV  R5,R30
	CPI  R30,0
	BREQ PC+3
	JMP _0x42
; 0000 0108            {
; 0000 0109 
; 0000 010A                         lcd_str("Drive 0: mounted");
	__POINTW1MN _0x3C,92
	CALL SUBOPT_0x6
; 0000 010B 
; 0000 010C 
; 0000 010D 
; 0000 010E                        if ((res=f_open(&file_1,path,FA_READ)) == FR_OK)
	CALL SUBOPT_0x7
	LDI  R30,LOW(_path)
	LDI  R31,HIGH(_path)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _f_open
	MOV  R5,R30
	CPI  R30,0
	BRNE _0x43
; 0000 010F                        {
; 0000 0110 
; 0000 0111 
; 0000 0112                                   lcd_goto_xy(0,0);
	CALL SUBOPT_0x0
	CALL SUBOPT_0x0
	RCALL _lcd_goto_xy
; 0000 0113 
; 0000 0114                                    if ((res=f_read(&file_1,Buffer,sizeof(Buffer)-1,&nbytes)) == FR_OK)
	CALL SUBOPT_0x7
	LDI  R30,LOW(_Buffer)
	LDI  R31,HIGH(_Buffer)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	CALL _f_read
	MOV  R5,R30
	CPI  R30,0
	BRNE _0x44
; 0000 0115                                    {
; 0000 0116 
; 0000 0117 
; 0000 0118                                           res = f_close(&file_1);
	CALL SUBOPT_0x7
	CALL _f_close
	MOV  R5,R30
; 0000 0119 
; 0000 011A 
; 0000 011B 
; 0000 011C 
; 0000 011D                                    }
; 0000 011E                                    else
	RJMP _0x45
_0x44:
; 0000 011F                                    {
; 0000 0120                                           lcd_str("file read err");
	__POINTW1MN _0x3C,109
	CALL SUBOPT_0x6
; 0000 0121 
; 0000 0122                                           delay_ms(2000);
	CALL SUBOPT_0x8
; 0000 0123                                    }
_0x45:
; 0000 0124 
; 0000 0125                        }
; 0000 0126                        else
	RJMP _0x46
_0x43:
; 0000 0127                        {
; 0000 0128                             lcd_str("file open err");
	__POINTW1MN _0x3C,123
	CALL SUBOPT_0x6
; 0000 0129 
; 0000 012A                             error(res);
	ST   -Y,R5
	RCALL _error
; 0000 012B                             delay_ms(2000);
	CALL SUBOPT_0x8
; 0000 012C                        }
_0x46:
; 0000 012D 
; 0000 012E 
; 0000 012F            }
; 0000 0130            else
	RJMP _0x47
_0x42:
; 0000 0131            {
; 0000 0132                       lcd_str("Error mounted");
	__POINTW1MN _0x3C,137
	CALL SUBOPT_0x6
; 0000 0133 
; 0000 0134                       error(res);
	ST   -Y,R5
	RCALL _error
; 0000 0135 
; 0000 0136                       delay_ms(2000);
	CALL SUBOPT_0x8
; 0000 0137            }
_0x47:
; 0000 0138 
; 0000 0139 
; 0000 013A 
; 0000 013B 
; 0000 013C while (1)
_0x48:
; 0000 013D       {
; 0000 013E       // Place your code here
; 0000 013F       };
	RJMP _0x48
; 0000 0140 }
_0x4B:
	RJMP _0x4B

	.DSEG
_0x3C:
	.BYTE 0x97

	.CSEG

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_wait_ready_G101:
	ST   -Y,R17
	LDI  R30,LOW(50)
	STS  _timer2_G101,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020004:
	SBIS 0xE,7
	RJMP _0x2020004
_0x2020008:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202000A:
	SBIS 0xE,7
	RJMP _0x202000A
	IN   R17,15
	CPI  R17,255
	BREQ _0x202000D
	LDS  R30,_timer2_G101
	CPI  R30,0
	BRNE _0x202000E
_0x202000D:
	RJMP _0x2020009
_0x202000E:
	RJMP _0x2020008
_0x2020009:
	MOV  R30,R17
	LD   R17,Y+
	RET
_release_spi_G101:
	SBI  0x18,4
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202000F:
	SBIS 0xE,7
	RJMP _0x202000F
	RET
_rx_datablock_G101:
	CALL __SAVELOCR4
	LDI  R30,LOW(10)
	STS  _timer1_G101,R30
_0x2020013:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020015:
	SBIS 0xE,7
	RJMP _0x2020015
	IN   R17,15
	CPI  R17,255
	BRNE _0x2020018
	LDS  R30,_timer1_G101
	CPI  R30,0
	BRNE _0x2020019
_0x2020018:
	RJMP _0x2020014
_0x2020019:
	RJMP _0x2020013
_0x2020014:
	CPI  R17,254
	BREQ _0x202001A
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x2100010
_0x202001A:
	__GETWRS 18,19,6
_0x202001C:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202001E:
	SBIS 0xE,7
	RJMP _0x202001E
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020021:
	SBIS 0xE,7
	RJMP _0x2020021
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020024:
	SBIS 0xE,7
	RJMP _0x2020024
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020027:
	SBIS 0xE,7
	RJMP _0x2020027
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,4
	STD  Y+4,R30
	STD  Y+4+1,R31
	BRNE _0x202001C
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202002A:
	SBIS 0xE,7
	RJMP _0x202002A
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202002D:
	SBIS 0xE,7
	RJMP _0x202002D
	LDI  R30,LOW(1)
	CALL __LOADLOCR4
	RJMP _0x2100010
_tx_datablock_G101:
	CALL __SAVELOCR4
	RCALL _wait_ready_G101
	CPI  R30,LOW(0xFF)
	BREQ _0x2020030
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x2100011
_0x2020030:
	LDD  R30,Y+4
	OUT  0xF,R30
_0x2020031:
	SBIS 0xE,7
	RJMP _0x2020031
	LDD  R26,Y+4
	CPI  R26,LOW(0xFD)
	BREQ _0x2020034
	LDI  R16,LOW(0)
	__GETWRS 18,19,5
_0x2020036:
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	OUT  0xF,R30
_0x2020038:
	SBIS 0xE,7
	RJMP _0x2020038
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	OUT  0xF,R30
_0x202003B:
	SBIS 0xE,7
	RJMP _0x202003B
	SUBI R16,LOW(1)
	CPI  R16,0
	BRNE _0x2020036
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202003E:
	SBIS 0xE,7
	RJMP _0x202003E
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020041:
	SBIS 0xE,7
	RJMP _0x2020041
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020044:
	SBIS 0xE,7
	RJMP _0x2020044
	IN   R17,15
	MOV  R30,R17
	ANDI R30,LOW(0x1F)
	CPI  R30,LOW(0x5)
	BREQ _0x2020047
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x2100011
_0x2020047:
_0x2020034:
	LDI  R30,LOW(1)
	CALL __LOADLOCR4
	RJMP _0x2100011
_send_cmd_G101:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+6
	ANDI R30,LOW(0x80)
	BREQ _0x2020048
	LDD  R30,Y+6
	ANDI R30,0x7F
	STD  Y+6,R30
	LDI  R30,LOW(119)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	MOV  R16,R30
	CPI  R16,2
	BRLO _0x2020049
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2100011
_0x2020049:
_0x2020048:
	SBI  0x18,4
	CBI  0x18,4
	RCALL _wait_ready_G101
	CPI  R30,LOW(0xFF)
	BREQ _0x202004A
	LDI  R30,LOW(255)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2100011
_0x202004A:
	LDD  R30,Y+6
	OUT  0xF,R30
_0x202004B:
	SBIS 0xE,7
	RJMP _0x202004B
	LDD  R30,Y+5
	OUT  0xF,R30
_0x202004E:
	SBIS 0xE,7
	RJMP _0x202004E
	LDD  R30,Y+4
	OUT  0xF,R30
_0x2020051:
	SBIS 0xE,7
	RJMP _0x2020051
	LDD  R30,Y+3
	OUT  0xF,R30
_0x2020054:
	SBIS 0xE,7
	RJMP _0x2020054
	LDD  R30,Y+2
	OUT  0xF,R30
_0x2020057:
	SBIS 0xE,7
	RJMP _0x2020057
	LDI  R17,LOW(1)
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BRNE _0x202005A
	LDI  R17,LOW(149)
	RJMP _0x202005B
_0x202005A:
	LDD  R26,Y+6
	CPI  R26,LOW(0x48)
	BRNE _0x202005C
	LDI  R17,LOW(135)
_0x202005C:
_0x202005B:
	OUT  0xF,R17
_0x202005D:
	SBIS 0xE,7
	RJMP _0x202005D
	LDD  R26,Y+6
	CPI  R26,LOW(0x4C)
	BRNE _0x2020060
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020061:
	SBIS 0xE,7
	RJMP _0x2020061
_0x2020060:
	LDI  R17,LOW(255)
_0x2020065:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020067:
	SBIS 0xE,7
	RJMP _0x2020067
	IN   R16,15
	SBRS R16,7
	RJMP _0x202006A
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202006B
_0x202006A:
	RJMP _0x2020066
_0x202006B:
	RJMP _0x2020065
_0x2020066:
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2100011
_rx_spi4_G101:
	ST   -Y,R17
	LDI  R17,4
_0x202006D:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202006F:
	SBIS 0xE,7
	RJMP _0x202006F
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,1
	STD  Y+1,R26
	STD  Y+1+1,R27
	SBIW R26,1
	IN   R30,0xF
	ST   X,R30
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202006D
	RJMP _0x210000F
_disk_initialize:
	SBIW R28,4
	CALL __SAVELOCR4
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x2020072
	LDI  R30,LOW(1)
	RJMP _0x2100016
_0x2020072:
	CBI  0x17,0
	CBI  0x17,1
	LDI  R30,LOW(10)
	STS  _timer1_G101,R30
_0x2020073:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BRNE _0x2020073
	LDS  R30,_status_G101
	ANDI R30,LOW(0x2)
	BREQ _0x2020076
	RJMP _0x2100015
_0x2020076:
	SBI  0x17,4
	SBI  0x18,4
	IN   R30,0x18
	ANDI R30,LOW(0x5F)
	OUT  0x18,R30
	SBI  0x18,6
	CBI  0x17,6
	IN   R30,0x17
	ORI  R30,LOW(0xB0)
	OUT  0x17,R30
	LDI  R30,LOW(83)
	OUT  0xD,R30
	LDI  R30,LOW(0)
	OUT  0xE,R30
	LDI  R19,LOW(255)
_0x2020078:
	LDI  R17,LOW(10)
_0x202007B:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202007D:
	SBIS 0xE,7
	RJMP _0x202007D
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202007B
	LDI  R30,LOW(64)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	MOV  R16,R30
	SUBI R19,LOW(1)
	CPI  R16,1
	BREQ _0x2020080
	CPI  R19,0
	BRNE _0x2020081
_0x2020080:
	RJMP _0x2020079
_0x2020081:
	RJMP _0x2020078
_0x2020079:
	LDI  R19,LOW(0)
	CPI  R16,1
	BREQ PC+3
	JMP _0x2020082
	LDI  R30,LOW(100)
	STS  _timer1_G101,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	__GETD1N 0x1AA
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,LOW(0x1)
	BRNE _0x2020083
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_spi4_G101
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0x2020085
	LDD  R26,Y+7
	CPI  R26,LOW(0xAA)
	BREQ _0x2020086
_0x2020085:
	RJMP _0x2020084
_0x2020086:
_0x2020087:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202008A
	LDI  R30,LOW(233)
	ST   -Y,R30
	__GETD1N 0x40000000
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x202008B
_0x202008A:
	RJMP _0x2020089
_0x202008B:
	RJMP _0x2020087
_0x2020089:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202008D
	LDI  R30,LOW(122)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BREQ _0x202008E
_0x202008D:
	RJMP _0x202008C
_0x202008E:
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_spi4_G101
	LDD  R30,Y+4
	ANDI R30,LOW(0x40)
	BREQ _0x202008F
	LDI  R30,LOW(12)
	RJMP _0x2020090
_0x202008F:
	LDI  R30,LOW(4)
_0x2020090:
	MOV  R19,R30
_0x202008C:
_0x2020084:
	RJMP _0x2020092
_0x2020083:
	LDI  R30,LOW(233)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,LOW(0x2)
	BRSH _0x2020093
	LDI  R19,LOW(2)
	LDI  R16,LOW(233)
	RJMP _0x2020094
_0x2020093:
	LDI  R19,LOW(1)
	LDI  R16,LOW(65)
_0x2020094:
_0x2020095:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x2020098
	ST   -Y,R16
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x2020099
_0x2020098:
	RJMP _0x2020097
_0x2020099:
	RJMP _0x2020095
_0x2020097:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202009B
	LDI  R30,LOW(80)
	ST   -Y,R30
	__GETD1N 0x200
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BREQ _0x202009A
_0x202009B:
	LDI  R19,LOW(0)
_0x202009A:
_0x2020092:
_0x2020082:
	STS  _card_type_G101,R19
	RCALL _release_spi_G101
	CPI  R19,0
	BREQ _0x202009D
	LDS  R30,_status_G101
	ANDI R30,0xFE
	STS  _status_G101,R30
	LDI  R30,LOW(80)
	OUT  0xD,R30
	LDI  R30,LOW(1)
	OUT  0xE,R30
	RJMP _0x202009E
_0x202009D:
	CBI  0x18,4
	RCALL _wait_ready_G101
	RCALL _release_spi_G101
	LDI  R30,LOW(0)
	OUT  0xD,R30
	IN   R30,0x17
	ANDI R30,LOW(0xF)
	OUT  0x17,R30
	IN   R30,0x18
	ANDI R30,LOW(0xF)
	OUT  0x18,R30
	CBI  0x17,4
	LDS  R30,_status_G101
	ORI  R30,1
	STS  _status_G101,R30
_0x202009E:
_0x2100015:
	LDS  R30,_status_G101
_0x2100016:
	CALL __LOADLOCR4
	ADIW R28,9
	RET
_disk_status:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x202009F
	LDI  R30,LOW(1)
	RJMP _0x2100014
_0x202009F:
	LDS  R30,_status_G101
_0x2100014:
	ADIW R28,1
	RET
_disk_read:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x20200A1
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20200A0
_0x20200A1:
	LDI  R30,LOW(4)
	RJMP _0x2100010
_0x20200A0:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x1)
	BREQ _0x20200A3
	LDI  R30,LOW(3)
	RJMP _0x2100010
_0x20200A3:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x8)
	BRNE _0x20200A4
	__GETD1S 1
	__GETD2N 0x200
	CALL __MULD12U
	__PUTD1S 1
_0x20200A4:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20200A5
	LDI  R30,LOW(81)
	ST   -Y,R30
	__GETD1S 2
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200A7
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200A8
_0x20200A7:
	RJMP _0x20200A6
_0x20200A8:
	LDI  R30,LOW(0)
	ST   Y,R30
_0x20200A6:
	RJMP _0x20200A9
_0x20200A5:
	LDI  R30,LOW(82)
	ST   -Y,R30
	__GETD1S 2
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200AA
_0x20200AC:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BREQ _0x20200AD
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SUBI R30,LOW(-512)
	SBCI R31,HIGH(-512)
	STD  Y+5,R30
	STD  Y+5+1,R31
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	BRNE _0x20200AC
_0x20200AD:
	LDI  R30,LOW(76)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
_0x20200AA:
_0x20200A9:
	RCALL _release_spi_G101
	LD   R30,Y
	CPI  R30,0
	BREQ _0x20200AF
	LDI  R30,LOW(1)
	RJMP _0x20200B0
_0x20200AF:
	LDI  R30,LOW(0)
_0x20200B0:
	RJMP _0x2100010
_disk_write:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x20200B3
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20200B2
_0x20200B3:
	LDI  R30,LOW(4)
	RJMP _0x2100010
_0x20200B2:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x1)
	BREQ _0x20200B5
	LDI  R30,LOW(3)
	RJMP _0x2100010
_0x20200B5:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x4)
	BREQ _0x20200B6
	LDI  R30,LOW(2)
	RJMP _0x2100010
_0x20200B6:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x8)
	BRNE _0x20200B7
	__GETD1S 1
	__GETD2N 0x200
	CALL __MULD12U
	__PUTD1S 1
_0x20200B7:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20200B8
	LDI  R30,LOW(88)
	ST   -Y,R30
	__GETD1S 2
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200BA
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _tx_datablock_G101
	CPI  R30,0
	BRNE _0x20200BB
_0x20200BA:
	RJMP _0x20200B9
_0x20200BB:
	LDI  R30,LOW(0)
	ST   Y,R30
_0x20200B9:
	RJMP _0x20200BC
_0x20200B8:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x6)
	BREQ _0x20200BD
	LDI  R30,LOW(215)
	ST   -Y,R30
	LDD  R30,Y+1
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RCALL _send_cmd_G101
_0x20200BD:
	LDI  R30,LOW(89)
	ST   -Y,R30
	__GETD1S 2
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200BE
_0x20200C0:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(252)
	ST   -Y,R30
	RCALL _tx_datablock_G101
	CPI  R30,0
	BREQ _0x20200C1
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SUBI R30,LOW(-512)
	SBCI R31,HIGH(-512)
	STD  Y+5,R30
	STD  Y+5+1,R31
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	BRNE _0x20200C0
_0x20200C1:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(253)
	ST   -Y,R30
	RCALL _tx_datablock_G101
	CPI  R30,0
	BRNE _0x20200C3
	LDI  R30,LOW(1)
	ST   Y,R30
_0x20200C3:
_0x20200BE:
_0x20200BC:
	RCALL _release_spi_G101
	LD   R30,Y
	CPI  R30,0
	BREQ _0x20200C4
	LDI  R30,LOW(1)
	RJMP _0x20200C5
_0x20200C4:
	LDI  R30,LOW(0)
_0x20200C5:
	RJMP _0x2100010
_disk_ioctl:
	SBIW R28,16
	CALL __SAVELOCR6
	LDD  R30,Y+25
	CPI  R30,0
	BREQ _0x20200C7
	LDI  R30,LOW(4)
	RJMP _0x2100013
_0x20200C7:
	LDI  R17,LOW(1)
	LDS  R30,_status_G101
	ANDI R30,LOW(0x1)
	BREQ _0x20200C8
	LDI  R30,LOW(3)
	RJMP _0x2100013
_0x20200C8:
	__GETWRS 20,21,22
	LDD  R30,Y+24
	CPI  R30,0
	BRNE _0x20200CC
	CBI  0x18,4
	RCALL _wait_ready_G101
	CPI  R30,LOW(0xFF)
	BRNE _0x20200CD
	LDI  R17,LOW(0)
_0x20200CD:
	RJMP _0x20200CB
_0x20200CC:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x20200CE
	LDI  R30,LOW(73)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200D0
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200D1
_0x20200D0:
	RJMP _0x20200CF
_0x20200D1:
	LDD  R30,Y+6
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	CPI  R30,LOW(0x1)
	BRNE _0x20200D2
	LDI  R30,0
	LDD  R31,Y+14
	LDD  R26,Y+15
	LDI  R27,0
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R18,R30
	MOVW R26,R18
	CLR  R24
	CLR  R25
	LDI  R30,LOW(10)
	RJMP _0x2020101
_0x20200D2:
	LDD  R30,Y+11
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LDD  R30,Y+16
	ANDI R30,LOW(0x80)
	ROL  R30
	LDI  R30,0
	ROL  R30
	ADD  R26,R30
	LDD  R30,Y+15
	ANDI R30,LOW(0x3)
	LSL  R30
	ADD  R30,R26
	SUBI R30,-LOW(2)
	MOV  R16,R30
	LDD  R30,Y+14
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	MOV  R26,R30
	LDD  R30,Y+13
	LDI  R31,0
	CALL __LSLW2
	LDI  R27,0
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+12
	ANDI R30,LOW(0x3)
	LDI  R31,0
	CALL __LSLW2
	MOV  R31,R30
	LDI  R30,0
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R18,R30
	MOVW R26,R18
	CLR  R24
	CLR  R25
	MOV  R30,R16
	SUBI R30,LOW(9)
_0x2020101:
	CALL __LSLD12
	MOVW R26,R20
	CALL __PUTDP1
	LDI  R17,LOW(0)
_0x20200CF:
	RJMP _0x20200CB
_0x20200CE:
	CPI  R30,LOW(0x2)
	BRNE _0x20200D4
	MOVW R26,R20
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	ST   X+,R30
	ST   X,R31
	LDI  R17,LOW(0)
	RJMP _0x20200CB
_0x20200D4:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x20200D5
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x4)
	BREQ _0x20200D6
	LDI  R30,LOW(205)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200D7
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x20200D8:
	SBIS 0xE,7
	RJMP _0x20200D8
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BREQ _0x20200DB
	LDI  R16,LOW(48)
_0x20200DD:
	CPI  R16,0
	BREQ _0x20200DE
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x20200DF:
	SBIS 0xE,7
	RJMP _0x20200DF
	SUBI R16,1
	RJMP _0x20200DD
_0x20200DE:
	LDD  R30,Y+16
	SWAP R30
	ANDI R30,0xF
	__GETD2N 0x10
	CALL __LSLD12
	MOVW R26,R20
	CALL __PUTDP1
	LDI  R17,LOW(0)
_0x20200DB:
_0x20200D7:
	RJMP _0x20200E2
_0x20200D6:
	LDI  R30,LOW(73)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200E4
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200E5
_0x20200E4:
	RJMP _0x20200E3
_0x20200E5:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x2)
	BREQ _0x20200E6
	LDD  R30,Y+16
	ANDI R30,LOW(0x3F)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __LSLD1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+17
	ANDI R30,LOW(0x80)
	CLR  R31
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(7)
	CALL __LSRD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	__ADDD1N 1
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+19
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	SUBI R30,LOW(1)
	CALL __LSLD12
	RJMP _0x2020102
_0x20200E6:
	LDD  R30,Y+16
	ANDI R30,LOW(0x7C)
	LSR  R30
	LSR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	__ADDD1N 1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+17
	ANDI R30,LOW(0x3)
	CLR  R31
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(3)
	CALL __LSLD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+17
	ANDI R30,LOW(0xE0)
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__ADDD1N 1
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULD12U
_0x2020102:
	MOVW R26,R20
	CALL __PUTDP1
	LDI  R17,LOW(0)
_0x20200E3:
_0x20200E2:
	RJMP _0x20200CB
_0x20200D5:
	CPI  R30,LOW(0xA)
	BRNE _0x20200E8
	LDS  R30,_card_type_G101
	MOVW R26,R20
	ST   X,R30
	LDI  R17,LOW(0)
	RJMP _0x20200CB
_0x20200E8:
	CPI  R30,LOW(0xB)
	BRNE _0x20200E9
	LDI  R30,LOW(73)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200EB
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200EC
_0x20200EB:
	RJMP _0x20200EA
_0x20200EC:
	LDI  R17,LOW(0)
_0x20200EA:
	RJMP _0x20200CB
_0x20200E9:
	CPI  R30,LOW(0xC)
	BRNE _0x20200ED
	LDI  R30,LOW(74)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200EF
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200F0
_0x20200EF:
	RJMP _0x20200EE
_0x20200F0:
	LDI  R17,LOW(0)
_0x20200EE:
	RJMP _0x20200CB
_0x20200ED:
	CPI  R30,LOW(0xD)
	BRNE _0x20200F1
	LDI  R30,LOW(122)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200F2
	ST   -Y,R21
	ST   -Y,R20
	RCALL _rx_spi4_G101
	LDI  R17,LOW(0)
_0x20200F2:
	RJMP _0x20200CB
_0x20200F1:
	CPI  R30,LOW(0xE)
	BRNE _0x20200F9
	LDI  R30,LOW(205)
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200F4
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x20200F5:
	SBIS 0xE,7
	RJMP _0x20200F5
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rx_datablock_G101
	CPI  R30,0
	BREQ _0x20200F8
	LDI  R17,LOW(0)
_0x20200F8:
_0x20200F4:
	RJMP _0x20200CB
_0x20200F9:
	LDI  R17,LOW(4)
_0x20200CB:
	RCALL _release_spi_G101
	MOV  R30,R17
_0x2100013:
	CALL __LOADLOCR6
	ADIW R28,26
	RET
_disk_timerproc:
	ST   -Y,R17
	ST   -Y,R16
	LDS  R17,_timer1_G101
	CPI  R17,0
	BREQ _0x20200FA
	SUBI R17,LOW(1)
	STS  _timer1_G101,R17
_0x20200FA:
	LDS  R17,_timer2_G101
	CPI  R17,0
	BREQ _0x20200FB
	SUBI R17,LOW(1)
	STS  _timer2_G101,R17
_0x20200FB:
	LDS  R17,_pv_S101000B000
	IN   R30,0x16
	ANDI R30,LOW(0x2)
	MOV  R26,R30
	IN   R30,0x16
	ANDI R30,LOW(0x1)
	OR   R30,R26
	STS  _pv_S101000B000,R30
	CP   R30,R17
	BRNE _0x20200FC
	LDS  R16,_status_G101
	ANDI R30,LOW(0x2)
	BREQ _0x20200FD
	ORI  R16,LOW(4)
	RJMP _0x20200FE
_0x20200FD:
	ANDI R16,LOW(251)
_0x20200FE:
	LDS  R30,_pv_S101000B000
	ANDI R30,LOW(0x1)
	BREQ _0x20200FF
	ORI  R16,LOW(3)
	RJMP _0x2020100
_0x20200FF:
	ANDI R16,LOW(253)
_0x2020100:
	STS  _status_G101,R16
_0x20200FC:
_0x2100012:
	LD   R16,Y+
	LD   R17,Y+
	RET

	.CSEG
_get_fattime:
	SBIW R28,7
	LDS  R26,_prtc_get_time
	LDS  R27,_prtc_get_time+1
	SBIW R26,0
	BREQ _0x2040004
	LDS  R26,_prtc_get_date
	LDS  R27,_prtc_get_date+1
	SBIW R26,0
	BRNE _0x2040003
_0x2040004:
	__GETD1N 0x3A210000
	RJMP _0x2100011
_0x2040003:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	__CALL1MN _prtc_get_time,0
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	__CALL1MN _prtc_get_date,0
	LD   R30,Y
	LDD  R31,Y+1
	SUBI R30,LOW(1980)
	SBCI R31,HIGH(1980)
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(25)
	CALL __LSLD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	CALL SUBOPT_0x9
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(21)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+3
	CALL SUBOPT_0x9
	CALL __LSLD16
	CALL __ORD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+6
	CALL SUBOPT_0x9
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(11)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	CALL SUBOPT_0x9
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(5)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+4
	LDI  R31,0
	ASR  R31
	ROR  R30
	CALL __CWD1
	CALL __ORD12
_0x2100011:
	ADIW R28,7
	RET
_mem_cpy_G102:
	CALL __SAVELOCR4
	__GETWRS 16,17,8
	__GETWRS 18,19,6
_0x2040006:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	ADIW R30,1
	BREQ _0x2040008
	PUSH R17
	PUSH R16
	__ADDWRN 16,17,1
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RJMP _0x2040006
_0x2040008:
	CALL __LOADLOCR4
	RJMP _0x210000C
_mem_set_G102:
	ST   -Y,R17
	ST   -Y,R16
	__GETWRS 16,17,6
_0x204000C:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	ADIW R30,1
	BREQ _0x204000E
	PUSH R17
	PUSH R16
	__ADDWRN 16,17,1
	LDD  R30,Y+4
	POP  R26
	POP  R27
	ST   X,R30
	RJMP _0x204000C
_0x204000E:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2100010:
	ADIW R28,8
	RET
_mem_cmp_G102:
	CALL __SAVELOCR6
	__GETWRS 16,17,10
	__GETWRS 18,19,8
	__GETWRN 20,21,0
_0x204000F:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	ADIW R30,1
	BREQ _0x2040012
	MOVW R26,R16
	__ADDWRN 16,17,1
	LD   R0,X
	CLR  R1
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R26,X
	CLR  R27
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	MOVW R20,R30
	SBIW R30,0
	BREQ _0x2040013
_0x2040012:
	RJMP _0x2040011
_0x2040013:
	RJMP _0x204000F
_0x2040011:
	MOVW R30,R20
	CALL __LOADLOCR6
	ADIW R28,12
	RET
_chk_chrf_G102:
_0x2040014:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x2040017
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R26,Z
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2040018
_0x2040017:
	RJMP _0x2040016
_0x2040018:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x2040014
_0x2040016:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R30,Z
	LDI  R31,0
	ADIW R28,4
	RET
_move_window_G102:
	SBIW R28,4
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,46
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
	CALL __CPD12
	BRNE PC+3
	JMP _0x2040019
	CALL SUBOPT_0xD
	CPI  R30,0
	BRNE PC+3
	JMP _0x204001A
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
	CPI  R30,0
	BREQ _0x204001B
	LDI  R30,LOW(1)
	RJMP _0x210000C
_0x204001B:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,4
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL SUBOPT_0x11
	MOVW R0,R26
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,26
	CALL __GETD1P
	MOVW R26,R0
	CALL __ADDD12
	CALL SUBOPT_0xC
	CALL __CPD21
	BRSH _0x204001C
	SBIW R28,1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,3
	LD   R30,X
	ST   Y,R30
_0x204001E:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRLO _0x204001F
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,26
	CALL __GETD1P
	CALL SUBOPT_0x12
	CALL __ADDD12
	__PUTD1S 1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,50
	CALL SUBOPT_0x13
	CALL SUBOPT_0x10
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	RJMP _0x204001E
_0x204001F:
	ADIW R28,1
_0x204001C:
_0x204001A:
	CALL SUBOPT_0xB
	CALL __CPD10
	BREQ _0x2040020
	CALL SUBOPT_0xE
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	BREQ _0x2040021
	LDI  R30,LOW(1)
	RJMP _0x210000C
_0x2040021:
	CALL SUBOPT_0xB
	__PUTD1SNS 8,46
_0x2040020:
_0x2040019:
	LDI  R30,LOW(0)
	RJMP _0x210000C
_sync_G102:
	ST   -Y,R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	CALL SUBOPT_0x16
	MOV  R17,R30
	CPI  R17,0
	BREQ PC+3
	JMP _0x2040022
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	CPI  R26,LOW(0x3)
	BRNE _0x2040024
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,9
	LD   R30,X
	CPI  R30,0
	BRNE _0x2040025
_0x2040024:
	RJMP _0x2040023
_0x2040025:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,50
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,50
	SUBI R30,LOW(-510)
	SBCI R31,HIGH(-510)
	LDI  R26,LOW(43605)
	LDI  R27,HIGH(43605)
	STD  Z+0,R26
	STD  Z+1,R27
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,50
	__GETD2N 0x41615252
	CALL SUBOPT_0x1A
	SUBI R30,LOW(-484)
	SBCI R31,HIGH(-484)
	__GETD2N 0x61417272
	CALL SUBOPT_0x1A
	SUBI R30,LOW(-488)
	SBCI R31,HIGH(-488)
	MOVW R0,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,14
	CALL SUBOPT_0x1B
	ADIW R30,50
	SUBI R30,LOW(-492)
	SBCI R31,HIGH(-492)
	MOVW R0,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,10
	CALL SUBOPT_0x1B
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,9
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040023:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL SUBOPT_0x0
	RCALL _disk_ioctl
	CPI  R30,0
	BREQ _0x2040026
	LDI  R17,LOW(1)
_0x2040026:
_0x2040022:
	MOV  R30,R17
_0x210000F:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_get_fat_G102:
	SBIW R28,4
	CALL __SAVELOCR4
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
	BRLO _0x2040028
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,30
	CALL __GETD1P
	CALL SUBOPT_0x1E
	CALL __CPD21
	BRLO _0x2040027
_0x2040028:
	CALL SUBOPT_0x20
	RJMP _0x210000E
_0x2040027:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,34
	CALL SUBOPT_0x21
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL SUBOPT_0x22
	BRNE _0x204002D
	__GETWRS 18,19,8
	MOVW R30,R18
	LSR  R31
	ROR  R30
	__ADDWRR 18,19,30,31
	CALL SUBOPT_0x23
	BREQ _0x204002E
	RJMP _0x204002C
_0x204002E:
	CALL SUBOPT_0x24
	LD   R16,X
	CLR  R17
	__ADDWRN 18,19,1
	CALL SUBOPT_0x23
	BRNE _0x204002C
	CALL SUBOPT_0x24
	LD   R30,X
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 16,17,30,31
	CALL SUBOPT_0x25
	ANDI R30,LOW(0x1)
	BREQ _0x2040030
	MOVW R30,R16
	CALL __LSRW4
	RJMP _0x2040229
_0x2040030:
	MOVW R30,R16
	ANDI R31,HIGH(0xFFF)
_0x2040229:
	CLR  R22
	CLR  R23
	RJMP _0x210000E
_0x204002D:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2040033
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	BRNE _0x204002C
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(2)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2A
	RJMP _0x210000E
_0x2040033:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x204002C
	CALL SUBOPT_0x26
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x28
	BRNE _0x204002C
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(4)
	CALL SUBOPT_0x29
	CALL __GETD1P
	__ANDD1N 0xFFFFFFF
	RJMP _0x210000E
_0x204002C:
	CALL SUBOPT_0x2C
_0x210000E:
	CALL __LOADLOCR4
	ADIW R28,14
	RET
_put_fat_G102:
	SBIW R28,4
	CALL __SAVELOCR6
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x1F
	BRLO _0x2040038
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,30
	CALL __GETD1P
	CALL SUBOPT_0x2D
	CALL __CPD21
	BRLO _0x2040037
_0x2040038:
	LDI  R21,LOW(2)
	RJMP _0x204003A
_0x2040037:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,34
	CALL __GETD1P
	__PUTD1S 6
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CALL SUBOPT_0x22
	BREQ PC+3
	JMP _0x204003E
	__GETWRS 16,17,14
	MOVW R30,R16
	LSR  R31
	ROR  R30
	__ADDWRR 16,17,30,31
	CALL SUBOPT_0x2E
	BREQ _0x204003F
	RJMP _0x204003D
_0x204003F:
	CALL SUBOPT_0x2F
	BREQ _0x2040040
	MOVW R26,R18
	LD   R30,X
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LDD  R30,Y+10
	LDI  R31,0
	CALL __LSLW4
	OR   R30,R26
	RJMP _0x2040041
_0x2040040:
	LDD  R30,Y+10
_0x2040041:
	MOVW R26,R18
	ST   X,R30
	__ADDWRN 16,17,1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	CALL SUBOPT_0x2E
	BREQ _0x2040043
	RJMP _0x204003D
_0x2040043:
	CALL SUBOPT_0x2F
	BREQ _0x2040044
	CALL SUBOPT_0x30
	LDI  R30,LOW(4)
	CALL __LSRD12
	CLR  R31
	CLR  R22
	CLR  R23
	RJMP _0x2040045
_0x2040044:
	MOVW R26,R18
	LD   R30,X
	ANDI R30,LOW(0xF0)
	MOV  R1,R30
	CALL SUBOPT_0x30
	LDI  R30,LOW(8)
	CALL __LSRD12
	CLR  R31
	CLR  R22
	CLR  R23
	ANDI R30,LOW(0xF)
	OR   R30,R1
_0x2040045:
	MOVW R26,R18
	ST   X,R30
	RJMP _0x204003D
_0x204003E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2040047
	CALL SUBOPT_0x31
	CALL SUBOPT_0x27
	CALL SUBOPT_0x32
	BRNE _0x204003D
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDI  R30,LOW(2)
	CALL SUBOPT_0x33
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	STD  Z+0,R26
	STD  Z+1,R27
	RJMP _0x204003D
_0x2040047:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x204004B
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x32
	BRNE _0x204003D
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDI  R30,LOW(4)
	CALL SUBOPT_0x33
	CALL SUBOPT_0x30
	CALL __PUTDZ20
	RJMP _0x204003D
_0x204004B:
	LDI  R21,LOW(2)
_0x204003D:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
_0x204003A:
	MOV  R30,R21
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_remove_chain_G102:
	SBIW R28,4
	ST   -Y,R17
	CALL SUBOPT_0x34
	CALL SUBOPT_0x1F
	BRLO _0x204004D
	CALL SUBOPT_0x35
	BRLO _0x204004C
_0x204004D:
	LDI  R17,LOW(2)
	RJMP _0x204004F
_0x204004C:
	LDI  R17,LOW(0)
_0x2040050:
	CALL SUBOPT_0x35
	BRSH _0x2040052
	CALL SUBOPT_0x36
	RCALL _get_fat_G102
	__PUTD1S 1
	CALL __CPD10
	BREQ _0x2040052
	CALL SUBOPT_0x12
	CALL SUBOPT_0x37
	BRNE _0x2040054
	LDI  R17,LOW(2)
	RJMP _0x2040052
_0x2040054:
	CALL SUBOPT_0x12
	CALL SUBOPT_0x38
	BRNE _0x2040055
	LDI  R17,LOW(1)
	RJMP _0x2040052
_0x2040055:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3A
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2040052
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x3B
	BREQ _0x2040057
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x3C
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,9
	LDI  R30,LOW(1)
	ST   X,R30
_0x2040057:
	__GETD1S 1
	__PUTD1S 5
	RJMP _0x2040050
_0x2040052:
_0x204004F:
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,11
	RET
_create_chain_G102:
	SBIW R28,16
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,30
	CALL SUBOPT_0xA
	CALL SUBOPT_0x3D
	CALL __CPD10
	BRNE _0x2040058
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,10
	CALL SUBOPT_0x21
	__GETD2S 4
	CALL __CPD02
	BREQ _0x204005A
	CALL SUBOPT_0x3E
	__GETD2S 4
	CALL __CPD21
	BRLO _0x2040059
_0x204005A:
	CALL SUBOPT_0x20
	CALL SUBOPT_0x3F
_0x2040059:
	RJMP _0x204005C
_0x2040058:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x41
	CALL SUBOPT_0x42
	CALL SUBOPT_0x43
	CALL SUBOPT_0x1F
	BRSH _0x204005D
	CALL SUBOPT_0x20
	RJMP _0x210000D
_0x204005D:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x43
	CALL __CPD21
	BRSH _0x204005E
	CALL SUBOPT_0x44
	RJMP _0x210000D
_0x204005E:
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x3F
_0x204005C:
	CALL SUBOPT_0xB
	CALL SUBOPT_0x45
_0x2040060:
	CALL SUBOPT_0x25
	__SUBD1N -1
	CALL SUBOPT_0x45
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x1E
	CALL __CPD21
	BRLO _0x2040062
	__GETD1N 0x2
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	BRSH _0x2040063
	CALL SUBOPT_0x39
	RJMP _0x210000D
_0x2040063:
_0x2040062:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x47
	CALL SUBOPT_0x42
	CALL SUBOPT_0x44
	CALL __CPD10
	BREQ _0x2040061
	CALL SUBOPT_0x43
	CALL SUBOPT_0x38
	BREQ _0x2040066
	CALL SUBOPT_0x43
	CALL SUBOPT_0x37
	BRNE _0x2040065
_0x2040066:
	CALL SUBOPT_0x44
	RJMP _0x210000D
_0x2040065:
	CALL SUBOPT_0x46
	BRNE _0x2040068
	CALL SUBOPT_0x39
	RJMP _0x210000D
_0x2040068:
	RJMP _0x2040060
_0x2040061:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x47
	__GETD1N 0xFFFFFFF
	CALL SUBOPT_0x3A
	CPI  R30,0
	BREQ _0x2040069
	CALL SUBOPT_0x2C
	RJMP _0x210000D
_0x2040069:
	CALL SUBOPT_0x3D
	CALL __CPD10
	BREQ _0x204006A
	CALL SUBOPT_0x40
	CALL SUBOPT_0x41
	__GETD1S 14
	CALL SUBOPT_0x3A
	CPI  R30,0
	BREQ _0x204006B
	CALL SUBOPT_0x2C
	RJMP _0x210000D
_0x204006B:
_0x204006A:
	CALL SUBOPT_0x25
	__PUTD1SNS 20,10
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	CALL SUBOPT_0x3B
	BREQ _0x204006C
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,14
	CALL __GETD1P_INC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	CALL __PUTDP1_DEC
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,9
	LDI  R30,LOW(1)
	ST   X,R30
_0x204006C:
	CALL SUBOPT_0x25
_0x210000D:
	ADIW R28,22
	RET
_clust2sect_G102:
	CALL SUBOPT_0x3E
	__SUBD1N 2
	CALL __PUTD1S0
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	__GETD2Z 30
	__GETD1N 0x2
	CALL SUBOPT_0x48
	CALL SUBOPT_0xC
	CALL __CPD21
	BRLO _0x204006D
	CALL SUBOPT_0x39
	RJMP _0x2100007
_0x204006D:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,2
	CALL SUBOPT_0x49
	CALL SUBOPT_0xC
	CALL __CWD1
	CALL __MULD12U
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,42
	CALL __GETD1P
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	RJMP _0x2100007
_dir_seek_G102:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	__PUTW1SNS 8,4
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,6
	CALL SUBOPT_0x4A
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x37
	BREQ _0x204006F
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	BRLO _0x204006E
_0x204006F:
	LDI  R30,LOW(2)
	RJMP _0x210000B
_0x204006E:
	CALL SUBOPT_0x4E
	BRNE _0x2040072
	CALL SUBOPT_0x4C
	LD   R26,Z
	CPI  R26,LOW(0x3)
	BREQ _0x2040073
_0x2040072:
	RJMP _0x2040071
_0x2040073:
	CALL SUBOPT_0x4C
	ADIW R30,38
	MOVW R26,R30
	CALL SUBOPT_0x4A
_0x2040071:
	CALL SUBOPT_0x4E
	BRNE _0x2040074
	CALL SUBOPT_0x4F
	ADIW R30,7
	MOVW R26,R30
	CALL __GETW1P
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2040075
	LDI  R30,LOW(2)
	RJMP _0x210000B
_0x2040075:
	CALL SUBOPT_0x4C
	ADIW R30,38
	MOVW R26,R30
	CALL __GETD1P
	RJMP _0x204022A
_0x2040074:
	CALL SUBOPT_0x4C
	LDD  R30,Z+2
	LDI  R26,LOW(16)
	MULS R30,R26
	MOVW R30,R0
	MOVW R16,R30
_0x2040077:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R16
	CPC  R27,R17
	BRLO _0x2040079
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x13
	CALL __PUTPARD1
	CALL SUBOPT_0x50
	CALL SUBOPT_0x38
	BRNE _0x204007A
	LDI  R30,LOW(1)
	RJMP _0x210000B
_0x204007A:
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x1F
	BRLO _0x204007C
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4D
	BRLO _0x204007B
_0x204007C:
	LDI  R30,LOW(2)
	RJMP _0x210000B
_0x204007B:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R16
	SBC  R31,R17
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2040077
_0x2040079:
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x13
	CALL SUBOPT_0x51
_0x204022A:
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __LSRW4
	CALL SUBOPT_0x52
	__PUTD1SNS 8,14
	CALL SUBOPT_0x4C
	ADIW R30,50
	MOVW R26,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x53
	__PUTW1SNS 8,18
	LDI  R30,LOW(0)
_0x210000B:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x210000C:
	ADIW R28,10
	RET
_dir_next_G102:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ADIW R26,4
	CALL __GETW1P
	ADIW R30,1
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x204007F
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ADIW R26,14
	CALL __GETD1P
	CALL __CPD10
	BRNE _0x204007E
_0x204007F:
	LDI  R30,LOW(4)
	RJMP _0x210000A
_0x204007E:
	MOVW R30,R16
	ANDI R30,LOW(0xF)
	BREQ PC+3
	JMP _0x2040081
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CALL SUBOPT_0x3C
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ADIW R26,10
	CALL __GETD1P
	CALL __CPD10
	BRNE _0x2040082
	CALL SUBOPT_0x54
	ADIW R30,7
	MOVW R26,R30
	CALL __GETW1P
	CP   R16,R30
	CPC  R17,R31
	BRLO _0x2040083
	LDI  R30,LOW(4)
	RJMP _0x210000A
_0x2040083:
	RJMP _0x2040084
_0x2040082:
	MOVW R30,R16
	CALL __LSRW4
	MOVW R0,R30
	CALL SUBOPT_0x54
	LDD  R30,Z+2
	LDI  R31,0
	SBIW R30,1
	AND  R30,R0
	AND  R31,R1
	SBIW R30,0
	BREQ PC+3
	JMP _0x2040085
	CALL SUBOPT_0x54
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x55
	CALL SUBOPT_0x50
	CALL SUBOPT_0x1F
	BRSH _0x2040086
	LDI  R30,LOW(2)
	RJMP _0x210000A
_0x2040086:
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x38
	BRNE _0x2040087
	LDI  R30,LOW(1)
	RJMP _0x210000A
_0x2040087:
	CALL SUBOPT_0x54
	CALL SUBOPT_0x4D
	BRSH PC+3
	JMP _0x2040088
	SBIW R28,1
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x2040089
	LDI  R30,LOW(4)
	ADIW R28,1
	RJMP _0x210000A
_0x2040089:
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x56
	CALL SUBOPT_0x55
	RCALL _create_chain_G102
	__PUTD1S 3
	CALL SUBOPT_0xF
	CALL __CPD10
	BRNE _0x204008A
	LDI  R30,LOW(7)
	ADIW R28,1
	RJMP _0x210000A
_0x204008A:
	__GETD2S 3
	CALL SUBOPT_0x37
	BRNE _0x204008B
	LDI  R30,LOW(2)
	ADIW R28,1
	RJMP _0x210000A
_0x204008B:
	__GETD2S 3
	CALL SUBOPT_0x38
	BRNE _0x204008C
	LDI  R30,LOW(1)
	ADIW R28,1
	RJMP _0x210000A
_0x204008C:
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x16
	CPI  R30,0
	BREQ _0x204008D
	LDI  R30,LOW(1)
	ADIW R28,1
	RJMP _0x210000A
_0x204008D:
	CALL SUBOPT_0x4C
	ADIW R30,50
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	CALL SUBOPT_0x4C
	MOVW R26,R30
	ADIW R30,46
	PUSH R31
	PUSH R30
	MOVW R30,R26
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 5
	CALL SUBOPT_0x51
	POP  R26
	POP  R27
	CALL __PUTDP1
	LDI  R30,LOW(0)
	ST   Y,R30
_0x204008F:
	CALL SUBOPT_0x4C
	LDD  R30,Z+2
	LD   R26,Y
	CP   R26,R30
	BRSH _0x2040090
	CALL SUBOPT_0x4C
	ADIW R30,4
	LDI  R26,LOW(1)
	STD  Z+0,R26
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x16
	CPI  R30,0
	BREQ _0x2040091
	LDI  R30,LOW(1)
	ADIW R28,1
	RJMP _0x210000A
_0x2040091:
	CALL SUBOPT_0x4C
	ADIW R30,46
	MOVW R26,R30
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x204008F
_0x2040090:
	CALL SUBOPT_0x4C
	ADIW R30,46
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	LD   R30,Y
	CALL SUBOPT_0x9
	CALL SUBOPT_0x48
	POP  R26
	POP  R27
	CALL __PUTDP1
	ADIW R28,1
_0x2040088:
	__GETD1S 2
	__PUTD1SNS 7,10
	CALL SUBOPT_0x54
	CALL SUBOPT_0x13
	CALL SUBOPT_0x51
	__PUTD1SNS 7,14
_0x2040085:
_0x2040084:
_0x2040081:
	MOVW R30,R16
	__PUTW1SNS 7,4
	CALL SUBOPT_0x54
	ADIW R30,50
	MOVW R26,R30
	MOVW R30,R16
	CALL SUBOPT_0x53
	__PUTW1SNS 7,18
	LDI  R30,LOW(0)
_0x210000A:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,9
	RET
_dir_find_G102:
	CALL SUBOPT_0x57
	RCALL _dir_seek_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x2040092
	MOV  R30,R17
	CALL __LOADLOCR4
	RJMP _0x2100007
_0x2040092:
_0x2040094:
	CALL SUBOPT_0x58
	BRNE _0x2040095
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,18
	LD   R18,X+
	LD   R19,X
	MOVW R26,R18
	LD   R16,X
	CPI  R16,0
	BRNE _0x2040097
	LDI  R17,LOW(4)
	RJMP _0x2040095
_0x2040097:
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x8)
	BRNE _0x2040099
	CALL SUBOPT_0x59
	RCALL _mem_cmp_G102
	SBIW R30,0
	BREQ _0x204009A
_0x2040099:
	RJMP _0x2040098
_0x204009A:
	RJMP _0x2040095
_0x2040098:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _dir_next_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x2040094
_0x2040095:
	MOV  R30,R17
	CALL __LOADLOCR4
	RJMP _0x2100007
_dir_register_G102:
	CALL SUBOPT_0x57
	RCALL _dir_seek_G102
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x20400A7
_0x20400A9:
	CALL SUBOPT_0x58
	BRNE _0x20400AA
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDD  R26,Z+18
	LDD  R27,Z+19
	LD   R16,X
	CPI  R16,229
	BREQ _0x20400AD
	CPI  R16,0
	BRNE _0x20400AC
_0x20400AD:
	RJMP _0x20400AA
_0x20400AC:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _dir_next_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x20400A9
_0x20400AA:
_0x20400A7:
	CPI  R17,0
	BRNE _0x20400AF
	CALL SUBOPT_0x58
	BRNE _0x20400B0
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,18
	LD   R18,X+
	LD   R19,X
	ST   -Y,R19
	ST   -Y,R18
	CALL SUBOPT_0x0
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mem_set_G102
	CALL SUBOPT_0x59
	RCALL _mem_cpy_G102
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,20
	CALL __GETW1P
	LDD  R30,Z+11
	ANDI R30,LOW(0x18)
	__PUTB1RNS 18,12
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	ADIW R30,4
	LDI  R26,LOW(1)
	STD  Z+0,R26
_0x20400B0:
_0x20400AF:
	MOV  R30,R17
	CALL __LOADLOCR4
	RJMP _0x2100007
_create_name_G102:
	SBIW R28,8
	CALL __SAVELOCR6
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,20
	LD   R20,X+
	LD   R21,X
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mem_set_G102
	LDI  R30,LOW(0)
	MOV  R17,R30
	LDI  R31,0
	STD  Y+8,R30
	STD  Y+8+1,R31
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	CALL SUBOPT_0x5A
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x2E)
	BRNE _0x20400B3
_0x20400B5:
	CALL SUBOPT_0x5B
	CPI  R16,46
	BRNE _0x20400B8
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,3
	BRLT _0x20400B7
_0x20400B8:
	RJMP _0x20400B6
_0x20400B7:
	CALL SUBOPT_0x5C
	RJMP _0x20400B5
_0x20400B6:
	CPI  R16,47
	BREQ _0x20400BB
	CPI  R16,92
	BREQ _0x20400BB
	CPI  R16,32
	BRSH _0x20400BC
_0x20400BB:
	RJMP _0x20400BA
_0x20400BC:
	LDI  R30,LOW(6)
	RJMP _0x2100008
_0x20400BA:
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x5D
	BRSH _0x20400BD
	LDI  R30,LOW(36)
	RJMP _0x20400BE
_0x20400BD:
	LDI  R30,LOW(32)
_0x20400BE:
	__PUTB1RNS 20,11
	RJMP _0x2100009
_0x20400B3:
_0x20400C1:
	CALL SUBOPT_0x5B
	CPI  R16,32
	BRLO _0x20400C4
	CPI  R16,47
	BREQ _0x20400C4
	CPI  R16,92
	BRNE _0x20400C3
_0x20400C4:
	RJMP _0x20400C2
_0x20400C3:
	CPI  R16,46
	BREQ _0x20400C7
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x20400C6
_0x20400C7:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,8
	BRNE _0x20400CA
	CPI  R16,46
	BREQ _0x20400C9
_0x20400CA:
	LDI  R30,LOW(6)
	RJMP _0x2100008
_0x20400C9:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	STD  Y+12,R30
	STD  Y+12+1,R31
	LSL  R17
	LSL  R17
	RJMP _0x20400C0
_0x20400C6:
	CPI  R16,128
	BRLO _0x20400CC
	ORI  R17,LOW(3)
	LDI  R30,LOW(6)
	RJMP _0x2100008
_0x20400CC:
	LDI  R30,LOW(_k1*2)
	LDI  R31,HIGH(_k1*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _chk_chrf_G102
	SBIW R30,0
	BREQ _0x20400D2
	LDI  R30,LOW(6)
	RJMP _0x2100008
_0x20400D2:
	CPI  R16,65
	BRLO _0x20400D4
	CPI  R16,91
	BRLO _0x20400D5
_0x20400D4:
	RJMP _0x20400D3
_0x20400D5:
	ORI  R17,LOW(2)
	RJMP _0x20400D6
_0x20400D3:
	CPI  R16,97
	BRLO _0x20400D8
	CPI  R16,123
	BRLO _0x20400D9
_0x20400D8:
	RJMP _0x20400D7
_0x20400D9:
	ORI  R17,LOW(1)
	MOV  R30,R16
	LDI  R31,0
	SBIW R30,32
	MOV  R16,R30
_0x20400D7:
_0x20400D6:
	CALL SUBOPT_0x5C
_0x20400C0:
	RJMP _0x20400C1
_0x20400C2:
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x5D
	BRSH _0x20400DA
	LDI  R30,LOW(4)
	RJMP _0x20400DB
_0x20400DA:
	LDI  R30,LOW(0)
_0x20400DB:
	MOV  R16,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SBIW R30,0
	BRNE _0x20400DD
	LDI  R30,LOW(6)
	RJMP _0x2100008
_0x20400DD:
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0xE5)
	BRNE _0x20400DE
	MOVW R26,R20
	LDI  R30,LOW(5)
	ST   X,R30
_0x20400DE:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,8
	BRNE _0x20400DF
	LSL  R17
	LSL  R17
_0x20400DF:
	MOV  R30,R17
	ANDI R30,LOW(0x3)
	CPI  R30,LOW(0x1)
	BRNE _0x20400E0
	ORI  R16,LOW(16)
_0x20400E0:
	MOV  R30,R17
	ANDI R30,LOW(0xC)
	CPI  R30,LOW(0x4)
	BRNE _0x20400E1
	ORI  R16,LOW(8)
_0x20400E1:
	MOVW R30,R20
	__PUTBZR 16,11
_0x2100009:
	LDI  R30,LOW(0)
_0x2100008:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_follow_path_G102:
	CALL __SAVELOCR4
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	CPI  R26,LOW(0x2F)
	BREQ _0x20400F8
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	CPI  R26,LOW(0x5C)
	BRNE _0x20400F7
_0x20400F8:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,6
	CALL SUBOPT_0x5E
	RJMP _0x20400FA
_0x20400F7:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	ADIW R30,22
	MOVW R26,R30
	CALL __GETD1P
	CALL SUBOPT_0x5F
_0x20400FA:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	CLR  R27
	SBIW R26,32
	BRSH _0x20400FB
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x18
	RCALL _dir_seek_G102
	MOV  R17,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,18
	CALL SUBOPT_0x60
	RJMP _0x20400FC
_0x20400FB:
_0x20400FE:
	CALL SUBOPT_0x61
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL _create_name_G102
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x20400FF
	CALL SUBOPT_0x61
	RCALL _dir_find_G102
	MOV  R17,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,20
	CALL __GETW1P
	LDD  R30,Z+11
	ANDI R30,LOW(0x4)
	MOV  R16,R30
	CPI  R17,0
	BREQ _0x2040101
	CPI  R17,4
	BRNE _0x2040103
	CPI  R16,0
	BREQ _0x2040104
_0x2040103:
	RJMP _0x2040102
_0x2040104:
	LDI  R17,LOW(5)
_0x2040102:
	RJMP _0x20400FF
_0x2040101:
	CPI  R16,0
	BRNE _0x20400FF
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,18
	LD   R18,X+
	LD   R19,X
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x10)
	BRNE _0x2040106
	LDI  R17,LOW(5)
	RJMP _0x20400FF
_0x2040106:
	CALL SUBOPT_0x62
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x63
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x64
	CALL SUBOPT_0x5F
	RJMP _0x20400FE
_0x20400FF:
_0x20400FC:
	MOV  R30,R17
	CALL __LOADLOCR4
	ADIW R28,8
	RET
_check_fs_G102:

	.DSEG

	.CSEG
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xF
	CALL __PUTPARD1
	CALL SUBOPT_0x15
	BREQ _0x2040108
	LDI  R30,LOW(3)
	RJMP _0x2100007
_0x2040108:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL SUBOPT_0x65
	BREQ _0x2040109
	LDI  R30,LOW(2)
	RJMP _0x2100007
_0x2040109:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUBI R30,LOW(-104)
	SBCI R31,HIGH(-104)
	CALL SUBOPT_0x66
	BRNE _0x204010A
	LDI  R30,LOW(0)
	RJMP _0x2100007
_0x204010A:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,50
	SUBI R30,LOW(-82)
	SBCI R31,HIGH(-82)
	CALL SUBOPT_0x66
	BRNE _0x204010C
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUBI R30,LOW(-90)
	SBCI R31,HIGH(-90)
	LD   R30,Z
	ANDI R30,LOW(0x80)
	BREQ _0x204010D
_0x204010C:
	RJMP _0x204010B
_0x204010D:
	LDI  R30,LOW(0)
	RJMP _0x2100007
_0x204010B:
	LDI  R30,LOW(1)
_0x2100007:
	ADIW R28,6
	RET
_auto_mount_G102:
	SBIW R28,21
	CALL __SAVELOCR6
	LDD  R26,Y+30
	LDD  R27,Y+30+1
	CALL __GETW1P
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL SUBOPT_0x49
	SBIW R30,48
	MOVW R20,R30
	__CPWRN 20,21,10
	BRSH _0x204010F
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	LD   R26,X
	CPI  R26,LOW(0x3A)
	BREQ _0x2040110
_0x204010F:
	RJMP _0x204010E
_0x2040110:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,2
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R26,Y+30
	LDD  R27,Y+30+1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2040111
_0x204010E:
	LDS  R20,_Drive_G102
	CLR  R21
_0x2040111:
	__CPWRN 20,21,1
	BRLO _0x2040112
	LDI  R30,LOW(11)
	RJMP _0x2100006
_0x2040112:
	MOVW R30,R20
	LDI  R26,LOW(_FatFs_G102)
	LDI  R27,HIGH(_FatFs_G102)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	ST   X+,R30
	ST   X,R31
	SBIW R30,0
	BRNE _0x2040113
	LDI  R30,LOW(12)
	RJMP _0x2100006
_0x2040113:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x2040114
	CALL SUBOPT_0x67
	CALL _disk_status
	STD  Y+26,R30
	ANDI R30,LOW(0x1)
	BRNE _0x2040115
	LDD  R30,Y+27
	CPI  R30,0
	BREQ _0x2040117
	LDD  R30,Y+26
	ANDI R30,LOW(0x4)
	BRNE _0x2040118
_0x2040117:
	RJMP _0x2040116
_0x2040118:
	LDI  R30,LOW(10)
	RJMP _0x2100006
_0x2040116:
	LDI  R30,LOW(0)
	RJMP _0x2100006
_0x2040115:
_0x2040114:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOV  R30,R20
	__PUTB1SNS 6,1
	CALL SUBOPT_0x67
	CALL _disk_initialize
	STD  Y+26,R30
	ANDI R30,LOW(0x1)
	BREQ _0x2040119
	LDI  R30,LOW(3)
	RJMP _0x2100006
_0x2040119:
	LDD  R30,Y+27
	CPI  R30,0
	BREQ _0x204011B
	LDD  R30,Y+26
	ANDI R30,LOW(0x4)
	BRNE _0x204011C
_0x204011B:
	RJMP _0x204011A
_0x204011C:
	LDI  R30,LOW(10)
	RJMP _0x2100006
_0x204011A:
	CALL SUBOPT_0x61
	CALL SUBOPT_0x39
	__PUTD1S 24
	CALL __PUTPARD1
	RCALL _check_fs_G102
	MOV  R16,R30
	CPI  R16,1
	BRNE _0x204011D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-446)
	SBCI R31,HIGH(-446)
	MOVW R18,R30
	MOVW R30,R18
	LDD  R30,Z+4
	CPI  R30,0
	BREQ _0x204011E
	MOVW R26,R18
	ADIW R26,8
	CALL __GETD1P
	__PUTD1S 22
	CALL SUBOPT_0x61
	__GETD1S 24
	CALL __PUTPARD1
	RCALL _check_fs_G102
	MOV  R16,R30
_0x204011E:
_0x204011D:
	CPI  R16,3
	BRNE _0x204011F
	LDI  R30,LOW(1)
	RJMP _0x2100006
_0x204011F:
	CPI  R16,0
	BRNE _0x2040121
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,61
	CALL __GETW1P
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BREQ _0x2040120
_0x2040121:
	LDI  R30,LOW(13)
	RJMP _0x2100006
_0x2040120:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-72)
	SBCI R27,HIGH(-72)
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x68
	CALL SUBOPT_0x69
	CALL __CPD10
	BRNE _0x2040123
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-86)
	SBCI R27,HIGH(-86)
	CALL __GETD1P
	CALL SUBOPT_0x68
_0x2040123:
	CALL SUBOPT_0x69
	__PUTD1SNS 6,26
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUBI R30,LOW(-66)
	SBCI R31,HIGH(-66)
	LD   R30,Z
	__PUTB1SNS 6,3
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,3
	CALL SUBOPT_0x49
	__GETD2S 18
	CALL __CWD1
	CALL __MULD12U
	CALL SUBOPT_0x68
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x6B
	__PUTD1SNS 6,34
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+63
	__PUTB1SNS 6,2
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-67)
	SBCI R27,HIGH(-67)
	CALL __GETW1P
	__PUTW1SNS 6,7
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-69)
	SBCI R27,HIGH(-69)
	CALL SUBOPT_0x2A
	__PUTD1S 14
	CALL __CPD10
	BRNE _0x2040124
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-82)
	SBCI R27,HIGH(-82)
	CALL __GETD1P
	__PUTD1S 14
_0x2040124:
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x2D
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x48
	__GETD2S 18
	CALL __SUBD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x6C
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x48
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,2
	CALL SUBOPT_0x49
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CWD1
	CALL __DIVD21U
	__ADDD1N 2
	__PUTD1S 10
	__PUTD1SNS 6,30
	LDI  R16,LOW(1)
	CALL SUBOPT_0x30
	__CPD2N 0xFF7
	BRLO _0x2040125
	LDI  R16,LOW(2)
_0x2040125:
	CALL SUBOPT_0x30
	__CPD2N 0xFFF7
	BRLO _0x2040126
	LDI  R16,LOW(3)
_0x2040126:
	CPI  R16,3
	BRNE _0x2040127
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-94)
	SBCI R27,HIGH(-94)
	CALL __GETD1P
	RJMP _0x204022B
_0x2040127:
	CALL SUBOPT_0x6D
_0x204022B:
	__PUTD1SNS 6,38
	CALL SUBOPT_0x6D
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x6C
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x52
	__PUTD1SNS 6,42
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,14
	CALL SUBOPT_0x2C
	CALL __PUTDP1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,4
	LDI  R30,LOW(0)
	ST   X,R30
	CPI  R16,3
	BREQ PC+3
	JMP _0x2040129
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,9
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-98)
	SBCI R27,HIGH(-98)
	CALL __GETW1P
	CALL SUBOPT_0x6B
	__PUTD1SNS 6,18
	CALL SUBOPT_0x67
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x15
	BRNE _0x204012B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x65
	BRNE _0x204012B
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,50
	CALL __GETD1P
	__CPD1N 0x41615252
	BRNE _0x204012B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-484)
	SBCI R31,HIGH(-484)
	MOVW R26,R30
	CALL __GETD1P
	__CPD1N 0x61417272
	BREQ _0x204012C
_0x204012B:
	RJMP _0x204012A
_0x204012C:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-492)
	SBCI R31,HIGH(-492)
	MOVW R26,R30
	CALL __GETD1P
	__PUTD1SNS 6,10
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-488)
	SBCI R31,HIGH(-488)
	MOVW R26,R30
	CALL __GETD1P
	__PUTD1SNS 6,14
_0x204012A:
_0x2040129:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R16
	CALL SUBOPT_0x17
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,22
	CALL SUBOPT_0x5E
	LDI  R26,LOW(_Fsid_G102)
	LDI  R27,HIGH(_Fsid_G102)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	__PUTW1SNS 6,5
	LDI  R17,LOW(0)
	MOV  R30,R17
_0x2100006:
	CALL __LOADLOCR6
	ADIW R28,32
	RET
_validate_G102:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x204012E
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x204012E
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+5
	LDD  R27,Z+6
	LD   R30,Y
	LDD  R31,Y+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x204012D
_0x204012E:
	LDI  R30,LOW(9)
	RJMP _0x2100005
_0x204012D:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+1
	ST   -Y,R26
	CALL _disk_status
	ANDI R30,LOW(0x1)
	BREQ _0x2040130
	LDI  R30,LOW(3)
	RJMP _0x2100005
_0x2040130:
	LDI  R30,LOW(0)
_0x2100005:
	ADIW R28,4
	RET
_f_mount:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRLO _0x2040131
	LDI  R30,LOW(11)
	RJMP _0x2100004
_0x2040131:
	LDD  R30,Y+4
	LDI  R26,LOW(_FatFs_G102)
	LDI  R27,HIGH(_FatFs_G102)
	CALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X+
	LD   R17,X
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040132
	MOVW R26,R16
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040132:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x2040133
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040133:
	LDD  R30,Y+4
	LDI  R26,LOW(_FatFs_G102)
	LDI  R27,HIGH(_FatFs_G102)
	CALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	STD  Z+0,R26
	STD  Z+1,R27
	LDI  R30,LOW(0)
_0x2100004:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
_f_open:
	SBIW R28,34
	CALL __SAVELOCR4
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CALL SUBOPT_0x60
	LDD  R30,Y+38
	ANDI R30,LOW(0x1F)
	STD  Y+38,R30
	MOVW R30,R28
	ADIW R30,39
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+42
	ANDI R30,LOW(0x1E)
	ST   -Y,R30
	RCALL _auto_mount_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x2040134
	MOV  R30,R17
	RJMP _0x2100003
_0x2040134:
	MOVW R30,R28
	ADIW R30,4
	STD  Y+36,R30
	STD  Y+36+1,R31
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _follow_path_G102
	MOV  R17,R30
	LDD  R30,Y+38
	ANDI R30,LOW(0x1C)
	BRNE PC+3
	JMP _0x2040135
	SBIW R28,8
	CPI  R17,0
	BREQ _0x2040136
	CPI  R17,4
	BRNE _0x2040137
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	RCALL _dir_register_G102
	MOV  R17,R30
_0x2040137:
	CPI  R17,0
	BREQ _0x2040138
	MOV  R30,R17
	ADIW R28,8
	RJMP _0x2100003
_0x2040138:
	LDD  R30,Y+46
	ORI  R30,8
	STD  Y+46,R30
	__GETWRS 18,19,42
	RJMP _0x2040139
_0x2040136:
	LDD  R30,Y+46
	ANDI R30,LOW(0x4)
	BREQ _0x204013A
	LDI  R30,LOW(8)
	ADIW R28,8
	RJMP _0x2100003
_0x204013A:
	__GETWRS 18,19,42
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x204013C
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x11)
	BREQ _0x204013B
_0x204013C:
	LDI  R30,LOW(7)
	ADIW R28,8
	RJMP _0x2100003
_0x204013B:
	LDD  R30,Y+46
	ANDI R30,LOW(0x8)
	BRNE PC+3
	JMP _0x204013E
	CALL SUBOPT_0x62
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x63
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x64
	CALL __PUTD1S0
	MOVW R30,R18
	ADIW R30,20
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
	MOVW R30,R18
	ADIW R30,26
	STD  Z+0,R26
	STD  Z+1,R27
	MOVW R30,R18
	ADIW R30,28
	__GETD2N 0x0
	CALL __PUTDZ20
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,46
	CALL SUBOPT_0x21
	CALL SUBOPT_0x3E
	CALL __CPD10
	BREQ _0x204013F
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 2
	CALL __PUTPARD1
	RCALL _remove_chain_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x2040140
	MOV  R30,R17
	ADIW R28,8
	RJMP _0x2100003
_0x2040140:
	CALL SUBOPT_0x3E
	__SUBD1N 1
	__PUTD1SNS 24,10
_0x204013F:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 6
	CALL __PUTPARD1
	CALL _move_window_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ _0x2040141
	MOV  R30,R17
	ADIW R28,8
	RJMP _0x2100003
_0x2040141:
_0x204013E:
_0x2040139:
	LDD  R30,Y+46
	ANDI R30,LOW(0x8)
	BREQ _0x2040142
	MOVW R30,R18
	ADIW R30,11
	LDI  R26,LOW(0)
	STD  Z+0,R26
	CALL SUBOPT_0x6E
	__PUTD1RNS 18,14
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	LDD  R30,Y+46
	ORI  R30,0x20
	STD  Y+46,R30
_0x2040142:
	ADIW R28,8
	RJMP _0x2040143
_0x2040135:
	CPI  R17,0
	BREQ _0x2040144
	MOV  R30,R17
	RJMP _0x2100003
_0x2040144:
	__GETWRS 18,19,34
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x2040146
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x10)
	BREQ _0x2040145
_0x2040146:
	LDI  R30,LOW(4)
	RJMP _0x2100003
_0x2040145:
	LDD  R30,Y+38
	ANDI R30,LOW(0x2)
	BREQ _0x2040149
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x1)
	BRNE _0x204014A
_0x2040149:
	RJMP _0x2040148
_0x204014A:
	LDI  R30,LOW(7)
	RJMP _0x2100003
_0x2040148:
_0x2040143:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,46
	CALL __GETD1P
	__PUTD1SNS 41,26
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	__PUTW1SNS 41,30
	LDD  R30,Y+38
	__PUTB1SNS 41,4
	CALL SUBOPT_0x62
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x63
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x64
	__PUTD1SNS 41,14
	MOVW R26,R18
	ADIW R26,28
	CALL __GETD1P
	__PUTD1SNS 41,10
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,6
	CALL SUBOPT_0x5E
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,5
	LDI  R30,LOW(255)
	ST   X,R30
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,22
	CALL SUBOPT_0x5E
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ST   X+,R30
	ST   X,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,5
	CALL __GETW1P
	__PUTW1SNS 41,2
	LDI  R30,LOW(0)
_0x2100003:
	CALL __LOADLOCR4
	ADIW R28,43
	RET
_f_read:
	SBIW R28,14
	CALL __SAVELOCR6
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CALL SUBOPT_0x60
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	CALL SUBOPT_0x71
	BREQ _0x204014B
	MOV  R30,R17
	RJMP _0x2100002
_0x204014B:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x80)
	BREQ _0x204014C
	LDI  R30,LOW(2)
	RJMP _0x2100002
_0x204014C:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x1)
	BRNE _0x204014D
	LDI  R30,LOW(7)
	RJMP _0x2100002
_0x204014D:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 10
	PUSH R25
	PUSH R24
	PUSH R27
	PUSH R26
	CALL SUBOPT_0x72
	POP  R30
	POP  R31
	POP  R22
	POP  R23
	CALL __SUBD12
	CALL SUBOPT_0x45
	CALL SUBOPT_0x25
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	CLR  R24
	CLR  R25
	CALL __CPD12
	BRSH _0x204014E
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	STD  Y+22,R30
	STD  Y+22+1,R31
_0x204014E:
_0x2040150:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x2040151
	CALL SUBOPT_0x72
	MOVW R30,R26
	MOVW R22,R24
	ANDI R31,HIGH(0x1FF)
	SBIW R30,0
	BREQ PC+3
	JMP _0x2040152
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R0,Z+5
	CALL SUBOPT_0x6F
	LDD  R30,Z+2
	CP   R0,R30
	BRLO _0x2040153
	CALL SUBOPT_0x72
	CALL __CPD02
	BRNE _0x2040154
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,14
	CALL __GETD1P
	RJMP _0x2040155
_0x2040154:
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	CALL SUBOPT_0x1C
	CALL _get_fat_G102
_0x2040155:
	__PUTD1S 16
	__GETD2S 16
	CALL SUBOPT_0x1F
	BRSH _0x2040157
	CALL SUBOPT_0x73
	LDI  R30,LOW(2)
	RJMP _0x2100002
_0x2040157:
	__GETD2S 16
	CALL SUBOPT_0x38
	BRNE _0x2040158
	CALL SUBOPT_0x73
	LDI  R30,LOW(1)
	RJMP _0x2100002
_0x2040158:
	CALL SUBOPT_0x3D
	__PUTD1SNS 26,18
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040153:
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	CALL SUBOPT_0x1C
	CALL _clust2sect_G102
	__PUTD1S 12
	CALL SUBOPT_0x44
	CALL __CPD10
	BRNE _0x2040159
	CALL SUBOPT_0x73
	LDI  R30,LOW(2)
	RJMP _0x2100002
_0x2040159:
	CALL SUBOPT_0x74
	CALL SUBOPT_0x43
	CALL __CWD1
	CALL __ADDD12
	__PUTD1S 12
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	MOVW R20,R30
	MOV  R0,R20
	OR   R0,R21
	BRNE PC+3
	JMP _0x204015A
	CALL SUBOPT_0x74
	ADD  R30,R20
	ADC  R31,R21
	MOVW R0,R30
	CALL SUBOPT_0x6F
	LDD  R30,Z+2
	MOVW R26,R0
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x204015B
	CALL SUBOPT_0x6F
	LDD  R0,Z+2
	CLR  R1
	CALL SUBOPT_0x74
	MOVW R26,R0
	SUB  R26,R30
	SBC  R27,R31
	MOVW R20,R26
_0x204015B:
	CALL SUBOPT_0x6F
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	CALL SUBOPT_0x75
	ST   -Y,R20
	CALL _disk_read
	CPI  R30,0
	BREQ _0x204015C
	CALL SUBOPT_0x73
	LDI  R30,LOW(1)
	RJMP _0x2100002
_0x204015C:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x204015E
	CALL SUBOPT_0x76
	CALL __SUBD21
	MOVW R30,R20
	CLR  R22
	CLR  R23
	CALL __CPD21
	BRLO _0x204015F
_0x204015E:
	RJMP _0x204015D
_0x204015F:
	CALL SUBOPT_0x76
	CALL __SUBD21
	__GETD1N 0x200
	CALL __MULD12U
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R24
	CLR  R25
	ADD  R30,R26
	ADC  R31,R27
	CALL SUBOPT_0x70
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	ST   -Y,R31
	ST   -Y,R30
	CALL _mem_cpy_G102
_0x204015D:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LD   R30,X
	ADD  R30,R20
	ST   X,R30
	MOVW R30,R20
	LSL  R30
	ROL  R31
	MOV  R31,R30
	LDI  R30,0
	MOVW R18,R30
	RJMP _0x204014F
_0x204015A:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x2040160
	CALL SUBOPT_0x6F
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+27
	LDD  R31,Y+27+1
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+29
	LDD  R31,Y+29+1
	CALL SUBOPT_0x77
	CPI  R30,0
	BREQ _0x2040161
	CALL SUBOPT_0x73
	LDI  R30,LOW(1)
	RJMP _0x2100002
_0x2040161:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,4
	LD   R30,X
	ANDI R30,0xBF
	ST   X,R30
_0x2040160:
	CALL SUBOPT_0x76
	CALL __CPD12
	BREQ _0x2040162
	CALL SUBOPT_0x6F
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+27
	LDD  R31,Y+27+1
	ADIW R30,32
	CALL SUBOPT_0x75
	CALL SUBOPT_0x15
	BREQ _0x2040163
	CALL SUBOPT_0x73
	LDI  R30,LOW(1)
	RJMP _0x2100002
_0x2040163:
_0x2040162:
	CALL SUBOPT_0x44
	__PUTD1SNS 26,22
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x2040152:
	CALL SUBOPT_0x72
	CALL SUBOPT_0x78
	__GETD2N 0x200
	CALL SUBOPT_0x48
	MOVW R18,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	CP   R30,R18
	CPC  R31,R19
	BRSH _0x2040164
	__GETWRS 18,19,22
_0x2040164:
	CALL SUBOPT_0x61
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	ADIW R30,32
	MOVW R0,R30
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	__GETD2Z 6
	CALL SUBOPT_0x78
	ADD  R30,R0
	ADC  R31,R1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R19
	ST   -Y,R18
	CALL _mem_cpy_G102
_0x204014F:
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	ADIW R30,6
	MOVW R0,R30
	MOVW R26,R30
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	MOVW R30,R18
	CALL SUBOPT_0x52
	MOVW R26,R0
	CALL __PUTDP1
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LD   R30,X+
	LD   R31,X+
	ADD  R30,R18
	ADC  R31,R19
	ST   -X,R31
	ST   -X,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+22,R30
	STD  Y+22+1,R31
	RJMP _0x2040150
_0x2040151:
	LDI  R30,LOW(0)
_0x2100002:
	CALL __LOADLOCR6
	ADIW R28,28
	RET
_f_sync:
	SBIW R28,4
	CALL __SAVELOCR4
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x56
	CALL SUBOPT_0x71
	BREQ PC+3
	JMP _0x2040181
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x20)
	BRNE PC+3
	JMP _0x2040182
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x2040183
	CALL SUBOPT_0x4C
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL SUBOPT_0x77
	CPI  R30,0
	BREQ _0x2040184
	LDI  R30,LOW(1)
	RJMP _0x2100001
_0x2040184:
	CALL SUBOPT_0xD
	ANDI R30,0xBF
	ST   X,R30
_0x2040183:
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x56
	__GETD2Z 26
	CALL __PUTPARD2
	CALL _move_window_G102
	MOV  R17,R30
	CPI  R17,0
	BREQ PC+3
	JMP _0x2040185
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,30
	LD   R18,X+
	LD   R19,X
	MOVW R26,R18
	ADIW R26,11
	LD   R30,X
	ORI  R30,0x20
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,10
	CALL __GETD1P
	__PUTD1RNS 18,28
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,14
	CALL __GETW1P
	__PUTW1RNS 18,26
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	__GETD2Z 14
	MOVW R30,R26
	MOVW R22,R24
	CALL __LSRD16
	__PUTW1RNS 18,20
	CALL SUBOPT_0x6E
	__PUTD1RNS 18,22
	CALL SUBOPT_0xD
	ANDI R30,0xDF
	ST   X,R30
	CALL SUBOPT_0x4C
	ADIW R30,4
	LDI  R26,LOW(1)
	STD  Z+0,R26
	CALL SUBOPT_0x4C
	ST   -Y,R31
	ST   -Y,R30
	CALL _sync_G102
	MOV  R17,R30
_0x2040185:
_0x2040182:
_0x2040181:
	MOV  R30,R17
_0x2100001:
	CALL __LOADLOCR4
	ADIW R28,10
	RET
_f_close:
	ST   -Y,R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _f_sync
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2040186
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x60
_0x2040186:
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,3
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_prtc_get_time:
	.BYTE 0x2
_prtc_get_date:
	.BYTE 0x2
_Buffer:
	.BYTE 0x100
_fat:
	.BYTE 0x232
_file_1:
	.BYTE 0x220
_path:
	.BYTE 0xA
__seed_G100:
	.BYTE 0x4
_status_G101:
	.BYTE 0x1
_timer1_G101:
	.BYTE 0x1
_timer2_G101:
	.BYTE 0x1
_card_type_G101:
	.BYTE 0x1
_pv_S101000B000:
	.BYTE 0x1
_FatFs_G102:
	.BYTE 0x2
_Fsid_G102:
	.BYTE 0x2
_Drive_G102:
	.BYTE 0x1
_fatstr_S1020016000:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_str

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(_file_1)
	LDI  R31,HIGH(_file_1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x9:
	LDI  R31,0
	CALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	CALL __GETD1P
	CALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xB:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	CALL __GETD2S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,4
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	__GETD1S 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _disk_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	__GETD2Z 34
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__GETD2S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	__GETD1S 7
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _disk_read
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x16:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	JMP  _move_window_G102

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	ADIW R26,46
	__GETD1N 0x0
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _mem_set_G102

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	CALL __PUTDZ20
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,50
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	CALL __GETD1P
	MOVW R26,R0
	CALL __PUTDP1
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1C:
	__GETD2Z 18
	CALL __PUTPARD2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _disk_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1E:
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x1F:
	__CPD2N 0x2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	__GETD1N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	CALL __GETD1P
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LD   R30,X
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x23:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R18
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	__GETD2S 6
	CLR  R22
	CLR  R23
	CALL __ADDD12
	CALL __PUTPARD1
	CALL _move_window_G102
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,50
	MOVW R30,R18
	ANDI R31,HIGH(0x1FF)
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	__GETD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x26:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	__GETD1N 0x100
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x28:
	__GETD2S 6
	CALL __ADDD12
	CALL __PUTPARD1
	CALL _move_window_G102
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	CALL __MULB1W2U
	ANDI R31,HIGH(0x1FF)
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,50
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2A:
	CALL __GETW1P
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	__GETD1N 0x80
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2C:
	__GETD1N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	__GETD2S 14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x2E:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R16
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	RCALL SUBOPT_0x1E
	CLR  R22
	CLR  R23
	CALL __ADDD12
	CALL __PUTPARD1
	CALL _move_window_G102
	MOV  R21,R30
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x2F:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,50
	MOVW R30,R16
	ANDI R31,HIGH(0x1FF)
	ADD  R30,R26
	ADC  R31,R27
	MOVW R18,R30
	__GETD1S 14
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x30:
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x32:
	RCALL SUBOPT_0x1E
	CALL __ADDD12
	CALL __PUTPARD1
	CALL _move_window_G102
	MOV  R21,R30
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	CALL __MULB1W2U
	ANDI R31,HIGH(0x1FF)
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,50
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x35:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,30
	CALL __GETD1P
	RCALL SUBOPT_0x34
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x37:
	__CPD2N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x38:
	__CPD2N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x39:
	__GETD1N 0x0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3A:
	CALL __PUTPARD1
	JMP  _put_fat_G102

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3B:
	__GETD2Z 14
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3C:
	ADIW R26,14
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	__GETD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3E:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3F:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	__GETD1S 18
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	CALL _get_fat_G102
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x43:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x44:
	__GETD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x45:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x46:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x1E
	CALL __CPD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	__GETD1S 10
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x48:
	CALL __SWAPD12
	CALL __SUBD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x49:
	LD   R30,X
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4A:
	CALL __GETD1P
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x4B:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0x4C:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4D:
	ADIW R30,30
	MOVW R26,R30
	CALL __GETD1P
	RCALL SUBOPT_0x4B
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	__GETD1S 2
	CALL __CPD10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4F:
	__GETD1S 2
	__PUTD1SNS 8,10
	RJMP SUBOPT_0x4C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x50:
	CALL _get_fat_G102
	__PUTD1S 2
	RJMP SUBOPT_0x4B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x51:
	CALL __PUTPARD1
	JMP  _clust2sect_G102

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x52:
	CLR  R22
	CLR  R23
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x53:
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	LSL  R30
	CALL __LSLW4
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x54:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x55:
	__GETD2Z 10
	CALL __PUTPARD2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x56:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x57:
	CALL __SAVELOCR4
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x58:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	__GETD2Z 14
	CALL __PUTPARD2
	CALL _move_window_G102
	MOV  R17,R30
	CPI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x59:
	ST   -Y,R19
	ST   -Y,R18
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+20
	LDD  R27,Z+21
	ST   -Y,R27
	ST   -Y,R26
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5A:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5B:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x5C:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	ADD  R30,R20
	ADC  R31,R21
	ST   Z,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5D:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ST   X+,R30
	ST   X,R31
	CPI  R16,32
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5E:
	RCALL SUBOPT_0x39
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5F:
	__PUTD1SNS 6,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x60:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x61:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x62:
	MOVW R26,R18
	ADIW R26,20
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x63:
	MOVW R26,R18
	ADIW R26,26
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x64:
	CLR  R22
	CLR  R23
	CALL __ORD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x65:
	ADIW R30,50
	SUBI R30,LOW(-510)
	SBCI R31,HIGH(-510)
	MOVW R26,R30
	CALL __GETW1P
	CPI  R30,LOW(0xAA55)
	LDI  R26,HIGH(0xAA55)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x66:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_fatstr_S1020016000)
	LDI  R31,HIGH(_fatstr_S1020016000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	CALL _mem_cmp_G102
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x67:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+1
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x68:
	__PUTD1S 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x69:
	__GETD1S 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-64)
	SBCI R27,HIGH(-64)
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6B:
	__GETD2S 22
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6C:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+7
	LDD  R27,Z+8
	MOVW R30,R26
	CALL __LSRW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x69
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6E:
	CALL _get_fattime
	RCALL SUBOPT_0x3F
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6F:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x70:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x71:
	LDD  R26,Z+2
	LDD  R27,Z+3
	ST   -Y,R27
	ST   -Y,R26
	CALL _validate_G102
	MOV  R17,R30
	CPI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x72:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x73:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,4
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	RJMP SUBOPT_0x49

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 15
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x76:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 22
	RJMP SUBOPT_0x44

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x77:
	__GETD2Z 22
	CALL __PUTPARD2
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x78:
	MOVW R30,R26
	MOVW R22,R24
	__ANDD1N 0x1FF
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__LSLD16:
	MOV  R22,R30
	MOV  R23,R31
	LDI  R30,0
	LDI  R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTDZ20:
	ST   Z,R26
	STD  Z+1,R27
	STD  Z+2,R24
	STD  Z+3,R25
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
